
/*
 * Copyright (C) 2011 Technische Universitaet Muenchen
 * This file is part of the Sierpinski project. For conditions of distribution and
 * use, please see the copyright notice in the file 'copyright.txt' at the root
 * directory of this package and the copyright notice at http://www5.in.tum.de/sierpinski
 *
 * This file was automatically generated by the sierpinski code generator
 */


inline void K_e_bbb_forward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		K_o_bbn_forward(depth);
		K_o_bob_forward(depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	cKernelClass.op_boundary_cell_to_edge_left(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	cKernelClass.op_cell_to_edge_left(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	cKernelClass.op_boundary_cell_to_edge_right(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	cKernelClass.op_cell_to_edge_right(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	cKernelClass.op_boundary_cell_to_edge_hyp(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	cKernelClass.op_cell_to_edge_hyp(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
}

inline void K_o_bbn_forward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		K_e_bnb_forward(depth);
		K_e_nbo_forward(depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	cKernelClass.op_boundary_cell_to_edge_right(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	cKernelClass.op_cell_to_edge_right(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	cKernelClass.op_cell_to_edge_left(depth, element_data, edge_data_comm_right_edge_stack->fakePush_returnPtr());
	cKernelClass.op_boundary_cell_to_edge_hyp(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	cKernelClass.op_cell_to_edge_hyp(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
}

inline void K_e_bnb_forward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		K_o_bbn_forward(depth);
		K_o_nob_forward(depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	cKernelClass.op_boundary_cell_to_edge_left(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	cKernelClass.op_cell_to_edge_left(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	cKernelClass.op_cell_to_edge_right(depth, element_data, edge_data_comm_left_edge_stack->fakePush_returnPtr());
	cKernelClass.op_boundary_cell_to_edge_hyp(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	cKernelClass.op_cell_to_edge_hyp(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
}

inline void K_o_nob_forward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		K_e_onn_forward(depth);
		K_e_bno_forward(depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	edge_comm_buffer->push_PtrValue(edge_data_comm_right_edge_stack->pop_returnPtr());
	cKernelClass.op_cell_to_edge_right(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	cKernelClass.op_boundary_cell_to_edge_left(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	cKernelClass.op_cell_to_edge_left(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	cKernelClass.op_cell_to_edge_hyp(depth, element_data, edge_data_comm_left_edge_stack->fakePush_returnPtr());
}

inline void K_e_onn_forward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		K_o_non_forward(depth);
		K_o_noo_forward(depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	cKernelClass.op_cell_to_edge_left(depth, element_data, edge_data_comm_left_edge_stack->fakePush_returnPtr());
	cKernelClass.op_cell_to_edge_right(depth, element_data, edge_data_comm_left_edge_stack->fakePush_returnPtr());
	edge_comm_buffer->push_PtrValue(edge_data_comm_right_edge_stack->pop_returnPtr());
	cKernelClass.op_cell_to_edge_hyp(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
}

inline void K_o_non_forward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		K_e_onn_forward(depth);
		K_e_nno_forward(depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	edge_comm_buffer->push_PtrValue(edge_data_comm_right_edge_stack->pop_returnPtr());
	cKernelClass.op_cell_to_edge_right(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	cKernelClass.op_cell_to_edge_left(depth, element_data, edge_data_comm_right_edge_stack->fakePush_returnPtr());
	cKernelClass.op_cell_to_edge_hyp(depth, element_data, edge_data_comm_left_edge_stack->fakePush_returnPtr());
}

inline void K_e_nno_forward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		K_o_onn_forward(depth);
		K_o_non_forward(depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	edge_comm_buffer->push_PtrValue(edge_data_comm_left_edge_stack->pop_returnPtr());
	cKernelClass.op_cell_to_edge_left(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	cKernelClass.op_cell_to_edge_right(depth, element_data, edge_data_comm_left_edge_stack->fakePush_returnPtr());
	cKernelClass.op_cell_to_edge_hyp(depth, element_data, edge_data_comm_right_edge_stack->fakePush_returnPtr());
}

inline void K_o_onn_forward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		K_e_nno_forward(depth);
		K_e_noo_forward(depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	cKernelClass.op_cell_to_edge_right(depth, element_data, edge_data_comm_right_edge_stack->fakePush_returnPtr());
	cKernelClass.op_cell_to_edge_left(depth, element_data, edge_data_comm_right_edge_stack->fakePush_returnPtr());
	edge_comm_buffer->push_PtrValue(edge_data_comm_left_edge_stack->pop_returnPtr());
	cKernelClass.op_cell_to_edge_hyp(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
}

inline void K_e_noo_forward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		K_o_onn_forward(depth);
		K_o_oon_forward(depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	edge_comm_buffer->push_PtrValue(edge_data_comm_left_edge_stack->pop_returnPtr());
	cKernelClass.op_cell_to_edge_left(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	edge_comm_buffer->push_PtrValue(edge_data_comm_left_edge_stack->pop_returnPtr());
	cKernelClass.op_cell_to_edge_right(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	cKernelClass.op_cell_to_edge_hyp(depth, element_data, edge_data_comm_right_edge_stack->fakePush_returnPtr());
}

inline void K_o_oon_forward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		K_e_ono_forward(depth);
		K_e_noo_forward(depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	edge_comm_buffer->push_PtrValue(edge_data_comm_right_edge_stack->pop_returnPtr());
	cKernelClass.op_cell_to_edge_right(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	cKernelClass.op_cell_to_edge_left(depth, element_data, edge_data_comm_right_edge_stack->fakePush_returnPtr());
	edge_comm_buffer->push_PtrValue(edge_data_comm_left_edge_stack->pop_returnPtr());
	cKernelClass.op_cell_to_edge_hyp(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
}

inline void K_e_ono_forward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		K_o_oon_forward(depth);
		K_o_noo_forward(depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	edge_comm_buffer->push_PtrValue(edge_data_comm_left_edge_stack->pop_returnPtr());
	cKernelClass.op_cell_to_edge_left(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	cKernelClass.op_cell_to_edge_right(depth, element_data, edge_data_comm_left_edge_stack->fakePush_returnPtr());
	edge_comm_buffer->push_PtrValue(edge_data_comm_right_edge_stack->pop_returnPtr());
	cKernelClass.op_cell_to_edge_hyp(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
}

inline void K_o_noo_forward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		K_e_onn_forward(depth);
		K_e_ono_forward(depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	edge_comm_buffer->push_PtrValue(edge_data_comm_right_edge_stack->pop_returnPtr());
	cKernelClass.op_cell_to_edge_right(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	edge_comm_buffer->push_PtrValue(edge_data_comm_right_edge_stack->pop_returnPtr());
	cKernelClass.op_cell_to_edge_left(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	cKernelClass.op_cell_to_edge_hyp(depth, element_data, edge_data_comm_left_edge_stack->fakePush_returnPtr());
}

inline void K_e_bno_forward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		K_o_obn_forward(depth);
		K_o_nob_forward(depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	edge_comm_buffer->push_PtrValue(edge_data_comm_left_edge_stack->pop_returnPtr());
	cKernelClass.op_cell_to_edge_left(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	cKernelClass.op_cell_to_edge_right(depth, element_data, edge_data_comm_left_edge_stack->fakePush_returnPtr());
	cKernelClass.op_boundary_cell_to_edge_hyp(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	cKernelClass.op_cell_to_edge_hyp(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
}

inline void K_o_obn_forward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		K_e_bno_forward(depth);
		K_e_noo_forward(depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	cKernelClass.op_boundary_cell_to_edge_right(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	cKernelClass.op_cell_to_edge_right(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	cKernelClass.op_cell_to_edge_left(depth, element_data, edge_data_comm_right_edge_stack->fakePush_returnPtr());
	edge_comm_buffer->push_PtrValue(edge_data_comm_left_edge_stack->pop_returnPtr());
	cKernelClass.op_cell_to_edge_hyp(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
}

inline void K_e_nbo_forward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		K_o_onn_forward(depth);
		K_o_bon_forward(depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	edge_comm_buffer->push_PtrValue(edge_data_comm_left_edge_stack->pop_returnPtr());
	cKernelClass.op_cell_to_edge_left(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	cKernelClass.op_boundary_cell_to_edge_right(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	cKernelClass.op_cell_to_edge_right(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	cKernelClass.op_cell_to_edge_hyp(depth, element_data, edge_data_comm_right_edge_stack->fakePush_returnPtr());
}

inline void K_o_bon_forward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		K_e_onb_forward(depth);
		K_e_nbo_forward(depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	edge_comm_buffer->push_PtrValue(edge_data_comm_right_edge_stack->pop_returnPtr());
	cKernelClass.op_cell_to_edge_right(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	cKernelClass.op_cell_to_edge_left(depth, element_data, edge_data_comm_right_edge_stack->fakePush_returnPtr());
	cKernelClass.op_boundary_cell_to_edge_hyp(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	cKernelClass.op_cell_to_edge_hyp(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
}

inline void K_e_onb_forward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		K_o_bon_forward(depth);
		K_o_noo_forward(depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	cKernelClass.op_boundary_cell_to_edge_left(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	cKernelClass.op_cell_to_edge_left(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	cKernelClass.op_cell_to_edge_right(depth, element_data, edge_data_comm_left_edge_stack->fakePush_returnPtr());
	edge_comm_buffer->push_PtrValue(edge_data_comm_right_edge_stack->pop_returnPtr());
	cKernelClass.op_cell_to_edge_hyp(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
}

inline void K_o_bob_forward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		K_e_onb_forward(depth);
		K_e_bbo_forward(depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	edge_comm_buffer->push_PtrValue(edge_data_comm_right_edge_stack->pop_returnPtr());
	cKernelClass.op_cell_to_edge_right(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	cKernelClass.op_boundary_cell_to_edge_left(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	cKernelClass.op_cell_to_edge_left(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	cKernelClass.op_boundary_cell_to_edge_hyp(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	cKernelClass.op_cell_to_edge_hyp(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
}

inline void K_e_bbo_forward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		K_o_obn_forward(depth);
		K_o_bob_forward(depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	edge_comm_buffer->push_PtrValue(edge_data_comm_left_edge_stack->pop_returnPtr());
	cKernelClass.op_cell_to_edge_left(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	cKernelClass.op_boundary_cell_to_edge_right(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	cKernelClass.op_cell_to_edge_right(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	cKernelClass.op_boundary_cell_to_edge_hyp(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	cKernelClass.op_cell_to_edge_hyp(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
}

inline void K_o_bbb_forward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		K_e_bnb_forward(depth);
		K_e_bbo_forward(depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	cKernelClass.op_boundary_cell_to_edge_right(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	cKernelClass.op_cell_to_edge_right(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	cKernelClass.op_boundary_cell_to_edge_left(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	cKernelClass.op_cell_to_edge_left(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	cKernelClass.op_boundary_cell_to_edge_hyp(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	cKernelClass.op_cell_to_edge_hyp(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
}

inline void K_e_nnn_forward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		K_o_nnn_forward(depth);
		K_o_non_forward(depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	cKernelClass.op_cell_to_edge_left(depth, element_data, edge_data_comm_left_edge_stack->fakePush_returnPtr());
	cKernelClass.op_cell_to_edge_right(depth, element_data, edge_data_comm_left_edge_stack->fakePush_returnPtr());
	cKernelClass.op_cell_to_edge_hyp(depth, element_data, edge_data_comm_right_edge_stack->fakePush_returnPtr());
}

inline void K_o_nnn_forward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		K_e_nnn_forward(depth);
		K_e_nno_forward(depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	cKernelClass.op_cell_to_edge_right(depth, element_data, edge_data_comm_right_edge_stack->fakePush_returnPtr());
	cKernelClass.op_cell_to_edge_left(depth, element_data, edge_data_comm_right_edge_stack->fakePush_returnPtr());
	cKernelClass.op_cell_to_edge_hyp(depth, element_data, edge_data_comm_left_edge_stack->fakePush_returnPtr());
}

inline void K_e_ooo_forward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		K_o_oon_forward(depth);
		K_o_ooo_forward(depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	edge_comm_buffer->push_PtrValue(edge_data_comm_left_edge_stack->pop_returnPtr());
	cKernelClass.op_cell_to_edge_left(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	edge_comm_buffer->push_PtrValue(edge_data_comm_left_edge_stack->pop_returnPtr());
	cKernelClass.op_cell_to_edge_right(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	edge_comm_buffer->push_PtrValue(edge_data_comm_right_edge_stack->pop_returnPtr());
	cKernelClass.op_cell_to_edge_hyp(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
}

inline void K_o_ooo_forward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		K_e_ono_forward(depth);
		K_e_ooo_forward(depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	edge_comm_buffer->push_PtrValue(edge_data_comm_right_edge_stack->pop_returnPtr());
	cKernelClass.op_cell_to_edge_right(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	edge_comm_buffer->push_PtrValue(edge_data_comm_right_edge_stack->pop_returnPtr());
	cKernelClass.op_cell_to_edge_left(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	edge_comm_buffer->push_PtrValue(edge_data_comm_left_edge_stack->pop_returnPtr());
	cKernelClass.op_cell_to_edge_hyp(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
}

inline void K_e_bnn_forward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		K_o_nbn_forward(depth);
		K_o_nob_forward(depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	cKernelClass.op_cell_to_edge_left(depth, element_data, edge_data_comm_left_edge_stack->fakePush_returnPtr());
	cKernelClass.op_cell_to_edge_right(depth, element_data, edge_data_comm_left_edge_stack->fakePush_returnPtr());
	cKernelClass.op_boundary_cell_to_edge_hyp(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	cKernelClass.op_cell_to_edge_hyp(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
}

inline void K_o_nbn_forward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		K_e_bnn_forward(depth);
		K_e_nno_forward(depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	cKernelClass.op_boundary_cell_to_edge_right(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	cKernelClass.op_cell_to_edge_right(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	cKernelClass.op_cell_to_edge_left(depth, element_data, edge_data_comm_right_edge_stack->fakePush_returnPtr());
	cKernelClass.op_cell_to_edge_hyp(depth, element_data, edge_data_comm_left_edge_stack->fakePush_returnPtr());
}

inline void K_o_bnn_forward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		K_e_nnb_forward(depth);
		K_e_nbo_forward(depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	cKernelClass.op_cell_to_edge_right(depth, element_data, edge_data_comm_right_edge_stack->fakePush_returnPtr());
	cKernelClass.op_cell_to_edge_left(depth, element_data, edge_data_comm_right_edge_stack->fakePush_returnPtr());
	cKernelClass.op_boundary_cell_to_edge_hyp(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	cKernelClass.op_cell_to_edge_hyp(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
}

inline void K_e_nnb_forward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		K_o_bnn_forward(depth);
		K_o_non_forward(depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	cKernelClass.op_boundary_cell_to_edge_left(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	cKernelClass.op_cell_to_edge_left(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	cKernelClass.op_cell_to_edge_right(depth, element_data, edge_data_comm_left_edge_stack->fakePush_returnPtr());
	cKernelClass.op_cell_to_edge_hyp(depth, element_data, edge_data_comm_right_edge_stack->fakePush_returnPtr());
}

inline void K_e_boo_forward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		K_o_obn_forward(depth);
		K_o_oob_forward(depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	edge_comm_buffer->push_PtrValue(edge_data_comm_left_edge_stack->pop_returnPtr());
	cKernelClass.op_cell_to_edge_left(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	edge_comm_buffer->push_PtrValue(edge_data_comm_left_edge_stack->pop_returnPtr());
	cKernelClass.op_cell_to_edge_right(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	cKernelClass.op_boundary_cell_to_edge_hyp(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	cKernelClass.op_cell_to_edge_hyp(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
}

inline void K_o_oob_forward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		K_e_ono_forward(depth);
		K_e_boo_forward(depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	edge_comm_buffer->push_PtrValue(edge_data_comm_right_edge_stack->pop_returnPtr());
	cKernelClass.op_cell_to_edge_right(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	cKernelClass.op_boundary_cell_to_edge_left(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	cKernelClass.op_cell_to_edge_left(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	edge_comm_buffer->push_PtrValue(edge_data_comm_left_edge_stack->pop_returnPtr());
	cKernelClass.op_cell_to_edge_hyp(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
}

inline void K_o_boo_forward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		K_e_onb_forward(depth);
		K_e_obo_forward(depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	edge_comm_buffer->push_PtrValue(edge_data_comm_right_edge_stack->pop_returnPtr());
	cKernelClass.op_cell_to_edge_right(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	edge_comm_buffer->push_PtrValue(edge_data_comm_right_edge_stack->pop_returnPtr());
	cKernelClass.op_cell_to_edge_left(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	cKernelClass.op_boundary_cell_to_edge_hyp(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	cKernelClass.op_cell_to_edge_hyp(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
}

inline void K_e_obo_forward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		K_o_oon_forward(depth);
		K_o_boo_forward(depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	edge_comm_buffer->push_PtrValue(edge_data_comm_left_edge_stack->pop_returnPtr());
	cKernelClass.op_cell_to_edge_left(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	cKernelClass.op_boundary_cell_to_edge_right(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	cKernelClass.op_cell_to_edge_right(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	edge_comm_buffer->push_PtrValue(edge_data_comm_right_edge_stack->pop_returnPtr());
	cKernelClass.op_cell_to_edge_hyp(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
}

inline void K_e_nbn_forward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		K_o_nnn_forward(depth);
		K_o_bon_forward(depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	cKernelClass.op_boundary_cell_to_edge_right(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	cKernelClass.op_cell_to_edge_right(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	cKernelClass.op_cell_to_edge_left(depth, element_data, edge_data_comm_left_edge_stack->fakePush_returnPtr());
	cKernelClass.op_cell_to_edge_hyp(depth, element_data, edge_data_comm_right_edge_stack->fakePush_returnPtr());
}

inline void K_o_obo_forward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		K_e_bno_forward(depth);
		K_e_ooo_forward(depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	cKernelClass.op_boundary_cell_to_edge_right(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	cKernelClass.op_cell_to_edge_right(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	edge_comm_buffer->push_PtrValue(edge_data_comm_right_edge_stack->pop_returnPtr());
	cKernelClass.op_cell_to_edge_left(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	edge_comm_buffer->push_PtrValue(edge_data_comm_left_edge_stack->pop_returnPtr());
	cKernelClass.op_cell_to_edge_hyp(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
}

inline void K_o_nnb_forward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		K_e_nnn_forward(depth);
		K_e_bno_forward(depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	cKernelClass.op_boundary_cell_to_edge_left(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	cKernelClass.op_cell_to_edge_left(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	cKernelClass.op_cell_to_edge_right(depth, element_data, edge_data_comm_right_edge_stack->fakePush_returnPtr());
	cKernelClass.op_cell_to_edge_hyp(depth, element_data, edge_data_comm_left_edge_stack->fakePush_returnPtr());
}

inline void K_e_oob_forward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		K_o_bon_forward(depth);
		K_o_ooo_forward(depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	cKernelClass.op_boundary_cell_to_edge_left(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	cKernelClass.op_cell_to_edge_left(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	edge_comm_buffer->push_PtrValue(edge_data_comm_left_edge_stack->pop_returnPtr());
	cKernelClass.op_cell_to_edge_right(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	edge_comm_buffer->push_PtrValue(edge_data_comm_right_edge_stack->pop_returnPtr());
	cKernelClass.op_cell_to_edge_hyp(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
}

inline void K_e_bbn_forward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		K_o_nbn_forward(depth);
		K_o_bob_forward(depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	cKernelClass.op_boundary_cell_to_edge_right(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	cKernelClass.op_cell_to_edge_right(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	cKernelClass.op_cell_to_edge_left(depth, element_data, edge_data_comm_left_edge_stack->fakePush_returnPtr());
	cKernelClass.op_boundary_cell_to_edge_hyp(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	cKernelClass.op_cell_to_edge_hyp(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
}

inline void K_o_bbo_forward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		K_e_bnb_forward(depth);
		K_e_obo_forward(depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	cKernelClass.op_boundary_cell_to_edge_right(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	cKernelClass.op_cell_to_edge_right(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	edge_comm_buffer->push_PtrValue(edge_data_comm_right_edge_stack->pop_returnPtr());
	cKernelClass.op_cell_to_edge_left(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	cKernelClass.op_boundary_cell_to_edge_hyp(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	cKernelClass.op_cell_to_edge_hyp(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
}

inline void K_e_nbb_forward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		K_o_bnn_forward(depth);
		K_o_bon_forward(depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	cKernelClass.op_boundary_cell_to_edge_left(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	cKernelClass.op_cell_to_edge_left(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	cKernelClass.op_boundary_cell_to_edge_right(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	cKernelClass.op_cell_to_edge_right(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	cKernelClass.op_cell_to_edge_hyp(depth, element_data, edge_data_comm_right_edge_stack->fakePush_returnPtr());
}

inline void K_o_nbb_forward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		K_e_bnn_forward(depth);
		K_e_bno_forward(depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	cKernelClass.op_boundary_cell_to_edge_right(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	cKernelClass.op_cell_to_edge_right(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	cKernelClass.op_boundary_cell_to_edge_left(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	cKernelClass.op_cell_to_edge_left(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	cKernelClass.op_cell_to_edge_hyp(depth, element_data, edge_data_comm_left_edge_stack->fakePush_returnPtr());
}

inline void K_e_obb_forward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		K_o_bon_forward(depth);
		K_o_boo_forward(depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	cKernelClass.op_boundary_cell_to_edge_left(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	cKernelClass.op_cell_to_edge_left(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	cKernelClass.op_boundary_cell_to_edge_right(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	cKernelClass.op_cell_to_edge_right(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	edge_comm_buffer->push_PtrValue(edge_data_comm_right_edge_stack->pop_returnPtr());
	cKernelClass.op_cell_to_edge_hyp(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
}

inline void K_o_obb_forward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		K_e_bno_forward(depth);
		K_e_boo_forward(depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	cKernelClass.op_boundary_cell_to_edge_right(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	cKernelClass.op_cell_to_edge_right(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	cKernelClass.op_boundary_cell_to_edge_left(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	cKernelClass.op_cell_to_edge_left(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	edge_comm_buffer->push_PtrValue(edge_data_comm_left_edge_stack->pop_returnPtr());
	cKernelClass.op_cell_to_edge_hyp(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
}

inline void K_o_bnb_forward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		K_e_nnb_forward(depth);
		K_e_bbo_forward(depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	cKernelClass.op_boundary_cell_to_edge_left(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	cKernelClass.op_cell_to_edge_left(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	cKernelClass.op_cell_to_edge_right(depth, element_data, edge_data_comm_right_edge_stack->fakePush_returnPtr());
	cKernelClass.op_boundary_cell_to_edge_hyp(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	cKernelClass.op_cell_to_edge_hyp(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
}

inline void K_e_bob_forward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		K_o_bbn_forward(depth);
		K_o_oob_forward(depth);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	CCellData *element_data = element_data_lifo.getNextDataPtr();
	cKernelClass.op_boundary_cell_to_edge_left(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	cKernelClass.op_cell_to_edge_left(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	edge_comm_buffer->push_PtrValue(edge_data_comm_left_edge_stack->pop_returnPtr());
	cKernelClass.op_cell_to_edge_right(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	cKernelClass.op_boundary_cell_to_edge_hyp(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
	cKernelClass.op_cell_to_edge_hyp(depth, element_data, edge_comm_buffer->fakePush_returnPtr());
}

/*
 * Copyright (C) 2011 Technische Universitaet Muenchen
 * This file is part of the Sierpinski project. For conditions of distribution and
 * use, please see the copyright notice in the file 'copyright.txt' at the root
 * directory of this package and the copyright notice at http://www5.in.tum.de/sierpinski
 *
 * This file was automatically generated by the sierpinski code generator
 */


inline void K_e_bbb_backward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		K_o_bnb_backward(depth);
		K_o_bbo_backward(depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	CEdgeData &netupdate_local_hyp_edge_data = edge_comm_buffer->pop_returnRef();
edge_comm_buffer->pop_returnRef();
	CEdgeData &netupdate_local_right_edge_data = edge_comm_buffer->pop_returnRef();
edge_comm_buffer->pop_returnRef();
	CEdgeData &netupdate_local_left_edge_data = edge_comm_buffer->pop_returnRef();
edge_comm_buffer->pop_returnRef();
	unsigned char adaptivity_request = 
	cKernelClass.op_cell(depth, element_data, &netupdate_local_hyp_edge_data, &netupdate_local_right_edge_data, &netupdate_local_left_edge_data);
	assert(adaptivity_request == 0 || adaptivity_request == 68 || adaptivity_request == 50);
	if (adaptivity_request == 0)
	{}
	else	// speculative loading optimized for first if-branch
	{
		if (adaptivity_request == 68)		// refine
		{
			if (depth >= depth_limiter_max)
				adaptivity_request = 0;
			else
				repeat_traversal = true;
		}
 	else if (adaptivity_request == 50)	// coarsen
		{
			if (depth <= depth_limiter_min)
				adaptivity_request = 0;
			else
				repeat_traversal = true;
		}
	}
	adaptivity_output_stream.push(adaptivity_request);
}

inline void K_o_bnb_backward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		K_e_bbn_backward(depth);
		K_e_nob_backward(depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	CEdgeData &netupdate_local_hyp_edge_data = edge_comm_buffer->pop_returnRef();
edge_comm_buffer->pop_returnRef();
	CEdgeData &netupdate_local_left_edge_data = edge_comm_buffer->pop_returnRef();
edge_comm_buffer->pop_returnRef();
	CEdgeData &netupdate_local_right_edge_data = edge_comm_buffer->pop_returnRef();
	CEdgeData &netupdate_adjacent_right_edge_data = edge_comm_buffer->pop_returnRef();
	edge_data_comm_left_edge_stack->push(netupdate_adjacent_right_edge_data);
	unsigned char adaptivity_request = 
	cKernelClass.op_cell(depth, element_data, &netupdate_local_hyp_edge_data, &netupdate_local_right_edge_data, &netupdate_local_left_edge_data);
	assert(adaptivity_request == 0 || adaptivity_request == 68 || adaptivity_request == 50);
	if (adaptivity_request == 0)
	{}
	else	// speculative loading optimized for first if-branch
	{
		if (adaptivity_request == 68)		// refine
		{
			if (depth >= depth_limiter_max)
				adaptivity_request = 0;
			else
				repeat_traversal = true;
		}
 	else if (adaptivity_request == 50)	// coarsen
		{
			if (depth <= depth_limiter_min)
				adaptivity_request = 0;
			else
				repeat_traversal = true;
		}
	}
	adaptivity_output_stream.push(adaptivity_request);
}

inline void K_e_bbn_backward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		K_o_bnb_backward(depth);
		K_o_nbo_backward(depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	CEdgeData &netupdate_local_hyp_edge_data = edge_comm_buffer->pop_returnRef();
edge_comm_buffer->pop_returnRef();
	CEdgeData &netupdate_local_right_edge_data = edge_comm_buffer->pop_returnRef();
edge_comm_buffer->pop_returnRef();
	CEdgeData &netupdate_local_left_edge_data = edge_comm_buffer->pop_returnRef();
	CEdgeData &netupdate_adjacent_left_edge_data = edge_comm_buffer->pop_returnRef();
	edge_data_comm_right_edge_stack->push(netupdate_adjacent_left_edge_data);
	unsigned char adaptivity_request = 
	cKernelClass.op_cell(depth, element_data, &netupdate_local_hyp_edge_data, &netupdate_local_right_edge_data, &netupdate_local_left_edge_data);
	assert(adaptivity_request == 0 || adaptivity_request == 68 || adaptivity_request == 50);
	if (adaptivity_request == 0)
	{}
	else	// speculative loading optimized for first if-branch
	{
		if (adaptivity_request == 68)		// refine
		{
			if (depth >= depth_limiter_max)
				adaptivity_request = 0;
			else
				repeat_traversal = true;
		}
 	else if (adaptivity_request == 50)	// coarsen
		{
			if (depth <= depth_limiter_min)
				adaptivity_request = 0;
			else
				repeat_traversal = true;
		}
	}
	adaptivity_output_stream.push(adaptivity_request);
}

inline void K_o_nbo_backward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		K_e_onn_backward(depth);
		K_e_bon_backward(depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	CEdgeData &netupdate_local_hyp_edge_data = edge_comm_buffer->pop_returnRef();
	CEdgeData &netupdate_adjacent_hyp_edge_data = edge_comm_buffer->pop_returnRef();
	CEdgeData netupdate_local_left_edge_data = edge_data_comm_left_edge_stack->pop_returnRef();
	CEdgeData &netupdate_local_right_edge_data = edge_comm_buffer->pop_returnRef();
edge_comm_buffer->pop_returnRef();
	edge_data_comm_right_edge_stack->push(netupdate_adjacent_hyp_edge_data);
	unsigned char adaptivity_request = 
	cKernelClass.op_cell(depth, element_data, &netupdate_local_hyp_edge_data, &netupdate_local_right_edge_data, &netupdate_local_left_edge_data);
	assert(adaptivity_request == 0 || adaptivity_request == 68 || adaptivity_request == 50);
	if (adaptivity_request == 0)
	{}
	else	// speculative loading optimized for first if-branch
	{
		if (adaptivity_request == 68)		// refine
		{
			if (depth >= depth_limiter_max)
				adaptivity_request = 0;
			else
				repeat_traversal = true;
		}
 	else if (adaptivity_request == 50)	// coarsen
		{
			if (depth <= depth_limiter_min)
				adaptivity_request = 0;
			else
				repeat_traversal = true;
		}
	}
	adaptivity_output_stream.push(adaptivity_request);
}

inline void K_e_onn_backward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		K_o_nno_backward(depth);
		K_o_noo_backward(depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	CEdgeData netupdate_local_hyp_edge_data = edge_data_comm_left_edge_stack->pop_returnRef();
	CEdgeData &netupdate_local_right_edge_data = edge_comm_buffer->pop_returnRef();
	CEdgeData &netupdate_adjacent_right_edge_data = edge_comm_buffer->pop_returnRef();
	CEdgeData &netupdate_local_left_edge_data = edge_comm_buffer->pop_returnRef();
	CEdgeData &netupdate_adjacent_left_edge_data = edge_comm_buffer->pop_returnRef();
	edge_data_comm_right_edge_stack->push(netupdate_adjacent_right_edge_data);
	edge_data_comm_right_edge_stack->push(netupdate_adjacent_left_edge_data);
	unsigned char adaptivity_request = 
	cKernelClass.op_cell(depth, element_data, &netupdate_local_hyp_edge_data, &netupdate_local_right_edge_data, &netupdate_local_left_edge_data);
	assert(adaptivity_request == 0 || adaptivity_request == 68 || adaptivity_request == 50);
	if (adaptivity_request == 0)
	{}
	else	// speculative loading optimized for first if-branch
	{
		if (adaptivity_request == 68)		// refine
		{
			if (depth >= depth_limiter_max)
				adaptivity_request = 0;
			else
				repeat_traversal = true;
		}
 	else if (adaptivity_request == 50)	// coarsen
		{
			if (depth <= depth_limiter_min)
				adaptivity_request = 0;
			else
				repeat_traversal = true;
		}
	}
	adaptivity_output_stream.push(adaptivity_request);
}

inline void K_o_nno_backward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		K_e_onn_backward(depth);
		K_e_non_backward(depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	CEdgeData &netupdate_local_hyp_edge_data = edge_comm_buffer->pop_returnRef();
	CEdgeData &netupdate_adjacent_hyp_edge_data = edge_comm_buffer->pop_returnRef();
	CEdgeData netupdate_local_left_edge_data = edge_data_comm_left_edge_stack->pop_returnRef();
	CEdgeData &netupdate_local_right_edge_data = edge_comm_buffer->pop_returnRef();
	CEdgeData &netupdate_adjacent_right_edge_data = edge_comm_buffer->pop_returnRef();
	edge_data_comm_right_edge_stack->push(netupdate_adjacent_hyp_edge_data);
	edge_data_comm_left_edge_stack->push(netupdate_adjacent_right_edge_data);
	unsigned char adaptivity_request = 
	cKernelClass.op_cell(depth, element_data, &netupdate_local_hyp_edge_data, &netupdate_local_right_edge_data, &netupdate_local_left_edge_data);
	assert(adaptivity_request == 0 || adaptivity_request == 68 || adaptivity_request == 50);
	if (adaptivity_request == 0)
	{}
	else	// speculative loading optimized for first if-branch
	{
		if (adaptivity_request == 68)		// refine
		{
			if (depth >= depth_limiter_max)
				adaptivity_request = 0;
			else
				repeat_traversal = true;
		}
 	else if (adaptivity_request == 50)	// coarsen
		{
			if (depth <= depth_limiter_min)
				adaptivity_request = 0;
			else
				repeat_traversal = true;
		}
	}
	adaptivity_output_stream.push(adaptivity_request);
}

inline void K_e_non_backward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		K_o_onn_backward(depth);
		K_o_nno_backward(depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	CEdgeData &netupdate_local_hyp_edge_data = edge_comm_buffer->pop_returnRef();
	CEdgeData &netupdate_adjacent_hyp_edge_data = edge_comm_buffer->pop_returnRef();
	CEdgeData netupdate_local_right_edge_data = edge_data_comm_right_edge_stack->pop_returnRef();
	CEdgeData &netupdate_local_left_edge_data = edge_comm_buffer->pop_returnRef();
	CEdgeData &netupdate_adjacent_left_edge_data = edge_comm_buffer->pop_returnRef();
	edge_data_comm_left_edge_stack->push(netupdate_adjacent_hyp_edge_data);
	edge_data_comm_right_edge_stack->push(netupdate_adjacent_left_edge_data);
	unsigned char adaptivity_request = 
	cKernelClass.op_cell(depth, element_data, &netupdate_local_hyp_edge_data, &netupdate_local_right_edge_data, &netupdate_local_left_edge_data);
	assert(adaptivity_request == 0 || adaptivity_request == 68 || adaptivity_request == 50);
	if (adaptivity_request == 0)
	{}
	else	// speculative loading optimized for first if-branch
	{
		if (adaptivity_request == 68)		// refine
		{
			if (depth >= depth_limiter_max)
				adaptivity_request = 0;
			else
				repeat_traversal = true;
		}
 	else if (adaptivity_request == 50)	// coarsen
		{
			if (depth <= depth_limiter_min)
				adaptivity_request = 0;
			else
				repeat_traversal = true;
		}
	}
	adaptivity_output_stream.push(adaptivity_request);
}

inline void K_o_onn_backward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		K_e_non_backward(depth);
		K_e_noo_backward(depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	CEdgeData netupdate_local_hyp_edge_data = edge_data_comm_right_edge_stack->pop_returnRef();
	CEdgeData &netupdate_local_left_edge_data = edge_comm_buffer->pop_returnRef();
	CEdgeData &netupdate_adjacent_left_edge_data = edge_comm_buffer->pop_returnRef();
	CEdgeData &netupdate_local_right_edge_data = edge_comm_buffer->pop_returnRef();
	CEdgeData &netupdate_adjacent_right_edge_data = edge_comm_buffer->pop_returnRef();
	edge_data_comm_left_edge_stack->push(netupdate_adjacent_left_edge_data);
	edge_data_comm_left_edge_stack->push(netupdate_adjacent_right_edge_data);
	unsigned char adaptivity_request = 
	cKernelClass.op_cell(depth, element_data, &netupdate_local_hyp_edge_data, &netupdate_local_right_edge_data, &netupdate_local_left_edge_data);
	assert(adaptivity_request == 0 || adaptivity_request == 68 || adaptivity_request == 50);
	if (adaptivity_request == 0)
	{}
	else	// speculative loading optimized for first if-branch
	{
		if (adaptivity_request == 68)		// refine
		{
			if (depth >= depth_limiter_max)
				adaptivity_request = 0;
			else
				repeat_traversal = true;
		}
 	else if (adaptivity_request == 50)	// coarsen
		{
			if (depth <= depth_limiter_min)
				adaptivity_request = 0;
			else
				repeat_traversal = true;
		}
	}
	adaptivity_output_stream.push(adaptivity_request);
}

inline void K_e_noo_backward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		K_o_onn_backward(depth);
		K_o_ono_backward(depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	CEdgeData &netupdate_local_hyp_edge_data = edge_comm_buffer->pop_returnRef();
	CEdgeData &netupdate_adjacent_hyp_edge_data = edge_comm_buffer->pop_returnRef();
	CEdgeData netupdate_local_right_edge_data = edge_data_comm_right_edge_stack->pop_returnRef();
	CEdgeData netupdate_local_left_edge_data = edge_data_comm_right_edge_stack->pop_returnRef();
	edge_data_comm_left_edge_stack->push(netupdate_adjacent_hyp_edge_data);
	unsigned char adaptivity_request = 
	cKernelClass.op_cell(depth, element_data, &netupdate_local_hyp_edge_data, &netupdate_local_right_edge_data, &netupdate_local_left_edge_data);
	assert(adaptivity_request == 0 || adaptivity_request == 68 || adaptivity_request == 50);
	if (adaptivity_request == 0)
	{}
	else	// speculative loading optimized for first if-branch
	{
		if (adaptivity_request == 68)		// refine
		{
			if (depth >= depth_limiter_max)
				adaptivity_request = 0;
			else
				repeat_traversal = true;
		}
 	else if (adaptivity_request == 50)	// coarsen
		{
			if (depth <= depth_limiter_min)
				adaptivity_request = 0;
			else
				repeat_traversal = true;
		}
	}
	adaptivity_output_stream.push(adaptivity_request);
}

inline void K_o_ono_backward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		K_e_oon_backward(depth);
		K_e_noo_backward(depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	CEdgeData netupdate_local_hyp_edge_data = edge_data_comm_right_edge_stack->pop_returnRef();
	CEdgeData netupdate_local_left_edge_data = edge_data_comm_left_edge_stack->pop_returnRef();
	CEdgeData &netupdate_local_right_edge_data = edge_comm_buffer->pop_returnRef();
	CEdgeData &netupdate_adjacent_right_edge_data = edge_comm_buffer->pop_returnRef();
	edge_data_comm_left_edge_stack->push(netupdate_adjacent_right_edge_data);
	unsigned char adaptivity_request = 
	cKernelClass.op_cell(depth, element_data, &netupdate_local_hyp_edge_data, &netupdate_local_right_edge_data, &netupdate_local_left_edge_data);
	assert(adaptivity_request == 0 || adaptivity_request == 68 || adaptivity_request == 50);
	if (adaptivity_request == 0)
	{}
	else	// speculative loading optimized for first if-branch
	{
		if (adaptivity_request == 68)		// refine
		{
			if (depth >= depth_limiter_max)
				adaptivity_request = 0;
			else
				repeat_traversal = true;
		}
 	else if (adaptivity_request == 50)	// coarsen
		{
			if (depth <= depth_limiter_min)
				adaptivity_request = 0;
			else
				repeat_traversal = true;
		}
	}
	adaptivity_output_stream.push(adaptivity_request);
}

inline void K_e_oon_backward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		K_o_ono_backward(depth);
		K_o_noo_backward(depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	CEdgeData netupdate_local_hyp_edge_data = edge_data_comm_left_edge_stack->pop_returnRef();
	CEdgeData netupdate_local_right_edge_data = edge_data_comm_right_edge_stack->pop_returnRef();
	CEdgeData &netupdate_local_left_edge_data = edge_comm_buffer->pop_returnRef();
	CEdgeData &netupdate_adjacent_left_edge_data = edge_comm_buffer->pop_returnRef();
	edge_data_comm_right_edge_stack->push(netupdate_adjacent_left_edge_data);
	unsigned char adaptivity_request = 
	cKernelClass.op_cell(depth, element_data, &netupdate_local_hyp_edge_data, &netupdate_local_right_edge_data, &netupdate_local_left_edge_data);
	assert(adaptivity_request == 0 || adaptivity_request == 68 || adaptivity_request == 50);
	if (adaptivity_request == 0)
	{}
	else	// speculative loading optimized for first if-branch
	{
		if (adaptivity_request == 68)		// refine
		{
			if (depth >= depth_limiter_max)
				adaptivity_request = 0;
			else
				repeat_traversal = true;
		}
 	else if (adaptivity_request == 50)	// coarsen
		{
			if (depth <= depth_limiter_min)
				adaptivity_request = 0;
			else
				repeat_traversal = true;
		}
	}
	adaptivity_output_stream.push(adaptivity_request);
}

inline void K_o_noo_backward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		K_e_onn_backward(depth);
		K_e_oon_backward(depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	CEdgeData &netupdate_local_hyp_edge_data = edge_comm_buffer->pop_returnRef();
	CEdgeData &netupdate_adjacent_hyp_edge_data = edge_comm_buffer->pop_returnRef();
	CEdgeData netupdate_local_left_edge_data = edge_data_comm_left_edge_stack->pop_returnRef();
	CEdgeData netupdate_local_right_edge_data = edge_data_comm_left_edge_stack->pop_returnRef();
	edge_data_comm_right_edge_stack->push(netupdate_adjacent_hyp_edge_data);
	unsigned char adaptivity_request = 
	cKernelClass.op_cell(depth, element_data, &netupdate_local_hyp_edge_data, &netupdate_local_right_edge_data, &netupdate_local_left_edge_data);
	assert(adaptivity_request == 0 || adaptivity_request == 68 || adaptivity_request == 50);
	if (adaptivity_request == 0)
	{}
	else	// speculative loading optimized for first if-branch
	{
		if (adaptivity_request == 68)		// refine
		{
			if (depth >= depth_limiter_max)
				adaptivity_request = 0;
			else
				repeat_traversal = true;
		}
 	else if (adaptivity_request == 50)	// coarsen
		{
			if (depth <= depth_limiter_min)
				adaptivity_request = 0;
			else
				repeat_traversal = true;
		}
	}
	adaptivity_output_stream.push(adaptivity_request);
}

inline void K_e_bon_backward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		K_o_onb_backward(depth);
		K_o_nbo_backward(depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	CEdgeData &netupdate_local_hyp_edge_data = edge_comm_buffer->pop_returnRef();
edge_comm_buffer->pop_returnRef();
	CEdgeData netupdate_local_right_edge_data = edge_data_comm_right_edge_stack->pop_returnRef();
	CEdgeData &netupdate_local_left_edge_data = edge_comm_buffer->pop_returnRef();
	CEdgeData &netupdate_adjacent_left_edge_data = edge_comm_buffer->pop_returnRef();
	edge_data_comm_right_edge_stack->push(netupdate_adjacent_left_edge_data);
	unsigned char adaptivity_request = 
	cKernelClass.op_cell(depth, element_data, &netupdate_local_hyp_edge_data, &netupdate_local_right_edge_data, &netupdate_local_left_edge_data);
	assert(adaptivity_request == 0 || adaptivity_request == 68 || adaptivity_request == 50);
	if (adaptivity_request == 0)
	{}
	else	// speculative loading optimized for first if-branch
	{
		if (adaptivity_request == 68)		// refine
		{
			if (depth >= depth_limiter_max)
				adaptivity_request = 0;
			else
				repeat_traversal = true;
		}
 	else if (adaptivity_request == 50)	// coarsen
		{
			if (depth <= depth_limiter_min)
				adaptivity_request = 0;
			else
				repeat_traversal = true;
		}
	}
	adaptivity_output_stream.push(adaptivity_request);
}

inline void K_o_onb_backward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		K_e_bon_backward(depth);
		K_e_noo_backward(depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	CEdgeData netupdate_local_hyp_edge_data = edge_data_comm_right_edge_stack->pop_returnRef();
	CEdgeData &netupdate_local_left_edge_data = edge_comm_buffer->pop_returnRef();
edge_comm_buffer->pop_returnRef();
	CEdgeData &netupdate_local_right_edge_data = edge_comm_buffer->pop_returnRef();
	CEdgeData &netupdate_adjacent_right_edge_data = edge_comm_buffer->pop_returnRef();
	edge_data_comm_left_edge_stack->push(netupdate_adjacent_right_edge_data);
	unsigned char adaptivity_request = 
	cKernelClass.op_cell(depth, element_data, &netupdate_local_hyp_edge_data, &netupdate_local_right_edge_data, &netupdate_local_left_edge_data);
	assert(adaptivity_request == 0 || adaptivity_request == 68 || adaptivity_request == 50);
	if (adaptivity_request == 0)
	{}
	else	// speculative loading optimized for first if-branch
	{
		if (adaptivity_request == 68)		// refine
		{
			if (depth >= depth_limiter_max)
				adaptivity_request = 0;
			else
				repeat_traversal = true;
		}
 	else if (adaptivity_request == 50)	// coarsen
		{
			if (depth <= depth_limiter_min)
				adaptivity_request = 0;
			else
				repeat_traversal = true;
		}
	}
	adaptivity_output_stream.push(adaptivity_request);
}

inline void K_e_nob_backward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		K_o_onn_backward(depth);
		K_o_bno_backward(depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	CEdgeData &netupdate_local_hyp_edge_data = edge_comm_buffer->pop_returnRef();
	CEdgeData &netupdate_adjacent_hyp_edge_data = edge_comm_buffer->pop_returnRef();
	CEdgeData netupdate_local_right_edge_data = edge_data_comm_right_edge_stack->pop_returnRef();
	CEdgeData &netupdate_local_left_edge_data = edge_comm_buffer->pop_returnRef();
edge_comm_buffer->pop_returnRef();
	edge_data_comm_left_edge_stack->push(netupdate_adjacent_hyp_edge_data);
	unsigned char adaptivity_request = 
	cKernelClass.op_cell(depth, element_data, &netupdate_local_hyp_edge_data, &netupdate_local_right_edge_data, &netupdate_local_left_edge_data);
	assert(adaptivity_request == 0 || adaptivity_request == 68 || adaptivity_request == 50);
	if (adaptivity_request == 0)
	{}
	else	// speculative loading optimized for first if-branch
	{
		if (adaptivity_request == 68)		// refine
		{
			if (depth >= depth_limiter_max)
				adaptivity_request = 0;
			else
				repeat_traversal = true;
		}
 	else if (adaptivity_request == 50)	// coarsen
		{
			if (depth <= depth_limiter_min)
				adaptivity_request = 0;
			else
				repeat_traversal = true;
		}
	}
	adaptivity_output_stream.push(adaptivity_request);
}

inline void K_o_bno_backward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		K_e_obn_backward(depth);
		K_e_nob_backward(depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	CEdgeData &netupdate_local_hyp_edge_data = edge_comm_buffer->pop_returnRef();
edge_comm_buffer->pop_returnRef();
	CEdgeData netupdate_local_left_edge_data = edge_data_comm_left_edge_stack->pop_returnRef();
	CEdgeData &netupdate_local_right_edge_data = edge_comm_buffer->pop_returnRef();
	CEdgeData &netupdate_adjacent_right_edge_data = edge_comm_buffer->pop_returnRef();
	edge_data_comm_left_edge_stack->push(netupdate_adjacent_right_edge_data);
	unsigned char adaptivity_request = 
	cKernelClass.op_cell(depth, element_data, &netupdate_local_hyp_edge_data, &netupdate_local_right_edge_data, &netupdate_local_left_edge_data);
	assert(adaptivity_request == 0 || adaptivity_request == 68 || adaptivity_request == 50);
	if (adaptivity_request == 0)
	{}
	else	// speculative loading optimized for first if-branch
	{
		if (adaptivity_request == 68)		// refine
		{
			if (depth >= depth_limiter_max)
				adaptivity_request = 0;
			else
				repeat_traversal = true;
		}
 	else if (adaptivity_request == 50)	// coarsen
		{
			if (depth <= depth_limiter_min)
				adaptivity_request = 0;
			else
				repeat_traversal = true;
		}
	}
	adaptivity_output_stream.push(adaptivity_request);
}

inline void K_e_obn_backward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		K_o_bno_backward(depth);
		K_o_noo_backward(depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	CEdgeData netupdate_local_hyp_edge_data = edge_data_comm_left_edge_stack->pop_returnRef();
	CEdgeData &netupdate_local_right_edge_data = edge_comm_buffer->pop_returnRef();
edge_comm_buffer->pop_returnRef();
	CEdgeData &netupdate_local_left_edge_data = edge_comm_buffer->pop_returnRef();
	CEdgeData &netupdate_adjacent_left_edge_data = edge_comm_buffer->pop_returnRef();
	edge_data_comm_right_edge_stack->push(netupdate_adjacent_left_edge_data);
	unsigned char adaptivity_request = 
	cKernelClass.op_cell(depth, element_data, &netupdate_local_hyp_edge_data, &netupdate_local_right_edge_data, &netupdate_local_left_edge_data);
	assert(adaptivity_request == 0 || adaptivity_request == 68 || adaptivity_request == 50);
	if (adaptivity_request == 0)
	{}
	else	// speculative loading optimized for first if-branch
	{
		if (adaptivity_request == 68)		// refine
		{
			if (depth >= depth_limiter_max)
				adaptivity_request = 0;
			else
				repeat_traversal = true;
		}
 	else if (adaptivity_request == 50)	// coarsen
		{
			if (depth <= depth_limiter_min)
				adaptivity_request = 0;
			else
				repeat_traversal = true;
		}
	}
	adaptivity_output_stream.push(adaptivity_request);
}

inline void K_o_bbo_backward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		K_e_obn_backward(depth);
		K_e_bob_backward(depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	CEdgeData &netupdate_local_hyp_edge_data = edge_comm_buffer->pop_returnRef();
edge_comm_buffer->pop_returnRef();
	CEdgeData netupdate_local_left_edge_data = edge_data_comm_left_edge_stack->pop_returnRef();
	CEdgeData &netupdate_local_right_edge_data = edge_comm_buffer->pop_returnRef();
edge_comm_buffer->pop_returnRef();
	unsigned char adaptivity_request = 
	cKernelClass.op_cell(depth, element_data, &netupdate_local_hyp_edge_data, &netupdate_local_right_edge_data, &netupdate_local_left_edge_data);
	assert(adaptivity_request == 0 || adaptivity_request == 68 || adaptivity_request == 50);
	if (adaptivity_request == 0)
	{}
	else	// speculative loading optimized for first if-branch
	{
		if (adaptivity_request == 68)		// refine
		{
			if (depth >= depth_limiter_max)
				adaptivity_request = 0;
			else
				repeat_traversal = true;
		}
 	else if (adaptivity_request == 50)	// coarsen
		{
			if (depth <= depth_limiter_min)
				adaptivity_request = 0;
			else
				repeat_traversal = true;
		}
	}
	adaptivity_output_stream.push(adaptivity_request);
}

inline void K_e_bob_backward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		K_o_onb_backward(depth);
		K_o_bbo_backward(depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	CEdgeData &netupdate_local_hyp_edge_data = edge_comm_buffer->pop_returnRef();
edge_comm_buffer->pop_returnRef();
	CEdgeData netupdate_local_right_edge_data = edge_data_comm_right_edge_stack->pop_returnRef();
	CEdgeData &netupdate_local_left_edge_data = edge_comm_buffer->pop_returnRef();
edge_comm_buffer->pop_returnRef();
	unsigned char adaptivity_request = 
	cKernelClass.op_cell(depth, element_data, &netupdate_local_hyp_edge_data, &netupdate_local_right_edge_data, &netupdate_local_left_edge_data);
	assert(adaptivity_request == 0 || adaptivity_request == 68 || adaptivity_request == 50);
	if (adaptivity_request == 0)
	{}
	else	// speculative loading optimized for first if-branch
	{
		if (adaptivity_request == 68)		// refine
		{
			if (depth >= depth_limiter_max)
				adaptivity_request = 0;
			else
				repeat_traversal = true;
		}
 	else if (adaptivity_request == 50)	// coarsen
		{
			if (depth <= depth_limiter_min)
				adaptivity_request = 0;
			else
				repeat_traversal = true;
		}
	}
	adaptivity_output_stream.push(adaptivity_request);
}

inline void K_o_bbb_backward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		K_e_bbn_backward(depth);
		K_e_bob_backward(depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	CEdgeData &netupdate_local_hyp_edge_data = edge_comm_buffer->pop_returnRef();
edge_comm_buffer->pop_returnRef();
	CEdgeData &netupdate_local_left_edge_data = edge_comm_buffer->pop_returnRef();
edge_comm_buffer->pop_returnRef();
	CEdgeData &netupdate_local_right_edge_data = edge_comm_buffer->pop_returnRef();
edge_comm_buffer->pop_returnRef();
	unsigned char adaptivity_request = 
	cKernelClass.op_cell(depth, element_data, &netupdate_local_hyp_edge_data, &netupdate_local_right_edge_data, &netupdate_local_left_edge_data);
	assert(adaptivity_request == 0 || adaptivity_request == 68 || adaptivity_request == 50);
	if (adaptivity_request == 0)
	{}
	else	// speculative loading optimized for first if-branch
	{
		if (adaptivity_request == 68)		// refine
		{
			if (depth >= depth_limiter_max)
				adaptivity_request = 0;
			else
				repeat_traversal = true;
		}
 	else if (adaptivity_request == 50)	// coarsen
		{
			if (depth <= depth_limiter_min)
				adaptivity_request = 0;
			else
				repeat_traversal = true;
		}
	}
	adaptivity_output_stream.push(adaptivity_request);
}

inline void K_e_nnn_backward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		K_o_nnn_backward(depth);
		K_o_nno_backward(depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	CEdgeData &netupdate_local_hyp_edge_data = edge_comm_buffer->pop_returnRef();
	CEdgeData &netupdate_adjacent_hyp_edge_data = edge_comm_buffer->pop_returnRef();
	CEdgeData &netupdate_local_right_edge_data = edge_comm_buffer->pop_returnRef();
	CEdgeData &netupdate_adjacent_right_edge_data = edge_comm_buffer->pop_returnRef();
	CEdgeData &netupdate_local_left_edge_data = edge_comm_buffer->pop_returnRef();
	CEdgeData &netupdate_adjacent_left_edge_data = edge_comm_buffer->pop_returnRef();
	edge_data_comm_left_edge_stack->push(netupdate_adjacent_hyp_edge_data);
	edge_data_comm_right_edge_stack->push(netupdate_adjacent_right_edge_data);
	edge_data_comm_right_edge_stack->push(netupdate_adjacent_left_edge_data);
	unsigned char adaptivity_request = 
	cKernelClass.op_cell(depth, element_data, &netupdate_local_hyp_edge_data, &netupdate_local_right_edge_data, &netupdate_local_left_edge_data);
	assert(adaptivity_request == 0 || adaptivity_request == 68 || adaptivity_request == 50);
	if (adaptivity_request == 0)
	{}
	else	// speculative loading optimized for first if-branch
	{
		if (adaptivity_request == 68)		// refine
		{
			if (depth >= depth_limiter_max)
				adaptivity_request = 0;
			else
				repeat_traversal = true;
		}
 	else if (adaptivity_request == 50)	// coarsen
		{
			if (depth <= depth_limiter_min)
				adaptivity_request = 0;
			else
				repeat_traversal = true;
		}
	}
	adaptivity_output_stream.push(adaptivity_request);
}

inline void K_o_nnn_backward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		K_e_nnn_backward(depth);
		K_e_non_backward(depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	CEdgeData &netupdate_local_hyp_edge_data = edge_comm_buffer->pop_returnRef();
	CEdgeData &netupdate_adjacent_hyp_edge_data = edge_comm_buffer->pop_returnRef();
	CEdgeData &netupdate_local_left_edge_data = edge_comm_buffer->pop_returnRef();
	CEdgeData &netupdate_adjacent_left_edge_data = edge_comm_buffer->pop_returnRef();
	CEdgeData &netupdate_local_right_edge_data = edge_comm_buffer->pop_returnRef();
	CEdgeData &netupdate_adjacent_right_edge_data = edge_comm_buffer->pop_returnRef();
	edge_data_comm_right_edge_stack->push(netupdate_adjacent_hyp_edge_data);
	edge_data_comm_left_edge_stack->push(netupdate_adjacent_left_edge_data);
	edge_data_comm_left_edge_stack->push(netupdate_adjacent_right_edge_data);
	unsigned char adaptivity_request = 
	cKernelClass.op_cell(depth, element_data, &netupdate_local_hyp_edge_data, &netupdate_local_right_edge_data, &netupdate_local_left_edge_data);
	assert(adaptivity_request == 0 || adaptivity_request == 68 || adaptivity_request == 50);
	if (adaptivity_request == 0)
	{}
	else	// speculative loading optimized for first if-branch
	{
		if (adaptivity_request == 68)		// refine
		{
			if (depth >= depth_limiter_max)
				adaptivity_request = 0;
			else
				repeat_traversal = true;
		}
 	else if (adaptivity_request == 50)	// coarsen
		{
			if (depth <= depth_limiter_min)
				adaptivity_request = 0;
			else
				repeat_traversal = true;
		}
	}
	adaptivity_output_stream.push(adaptivity_request);
}

inline void K_e_ooo_backward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		K_o_ono_backward(depth);
		K_o_ooo_backward(depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	CEdgeData netupdate_local_hyp_edge_data = edge_data_comm_left_edge_stack->pop_returnRef();
	CEdgeData netupdate_local_right_edge_data = edge_data_comm_right_edge_stack->pop_returnRef();
	CEdgeData netupdate_local_left_edge_data = edge_data_comm_right_edge_stack->pop_returnRef();
	unsigned char adaptivity_request = 
	cKernelClass.op_cell(depth, element_data, &netupdate_local_hyp_edge_data, &netupdate_local_right_edge_data, &netupdate_local_left_edge_data);
	assert(adaptivity_request == 0 || adaptivity_request == 68 || adaptivity_request == 50);
	if (adaptivity_request == 0)
	{}
	else	// speculative loading optimized for first if-branch
	{
		if (adaptivity_request == 68)		// refine
		{
			if (depth >= depth_limiter_max)
				adaptivity_request = 0;
			else
				repeat_traversal = true;
		}
 	else if (adaptivity_request == 50)	// coarsen
		{
			if (depth <= depth_limiter_min)
				adaptivity_request = 0;
			else
				repeat_traversal = true;
		}
	}
	adaptivity_output_stream.push(adaptivity_request);
}

inline void K_o_ooo_backward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		K_e_oon_backward(depth);
		K_e_ooo_backward(depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	CEdgeData netupdate_local_hyp_edge_data = edge_data_comm_right_edge_stack->pop_returnRef();
	CEdgeData netupdate_local_left_edge_data = edge_data_comm_left_edge_stack->pop_returnRef();
	CEdgeData netupdate_local_right_edge_data = edge_data_comm_left_edge_stack->pop_returnRef();
	unsigned char adaptivity_request = 
	cKernelClass.op_cell(depth, element_data, &netupdate_local_hyp_edge_data, &netupdate_local_right_edge_data, &netupdate_local_left_edge_data);
	assert(adaptivity_request == 0 || adaptivity_request == 68 || adaptivity_request == 50);
	if (adaptivity_request == 0)
	{}
	else	// speculative loading optimized for first if-branch
	{
		if (adaptivity_request == 68)		// refine
		{
			if (depth >= depth_limiter_max)
				adaptivity_request = 0;
			else
				repeat_traversal = true;
		}
 	else if (adaptivity_request == 50)	// coarsen
		{
			if (depth <= depth_limiter_min)
				adaptivity_request = 0;
			else
				repeat_traversal = true;
		}
	}
	adaptivity_output_stream.push(adaptivity_request);
}

inline void K_e_bnn_backward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		K_o_nnb_backward(depth);
		K_o_nbo_backward(depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	CEdgeData &netupdate_local_hyp_edge_data = edge_comm_buffer->pop_returnRef();
edge_comm_buffer->pop_returnRef();
	CEdgeData &netupdate_local_right_edge_data = edge_comm_buffer->pop_returnRef();
	CEdgeData &netupdate_adjacent_right_edge_data = edge_comm_buffer->pop_returnRef();
	CEdgeData &netupdate_local_left_edge_data = edge_comm_buffer->pop_returnRef();
	CEdgeData &netupdate_adjacent_left_edge_data = edge_comm_buffer->pop_returnRef();
	edge_data_comm_right_edge_stack->push(netupdate_adjacent_right_edge_data);
	edge_data_comm_right_edge_stack->push(netupdate_adjacent_left_edge_data);
	unsigned char adaptivity_request = 
	cKernelClass.op_cell(depth, element_data, &netupdate_local_hyp_edge_data, &netupdate_local_right_edge_data, &netupdate_local_left_edge_data);
	assert(adaptivity_request == 0 || adaptivity_request == 68 || adaptivity_request == 50);
	if (adaptivity_request == 0)
	{}
	else	// speculative loading optimized for first if-branch
	{
		if (adaptivity_request == 68)		// refine
		{
			if (depth >= depth_limiter_max)
				adaptivity_request = 0;
			else
				repeat_traversal = true;
		}
 	else if (adaptivity_request == 50)	// coarsen
		{
			if (depth <= depth_limiter_min)
				adaptivity_request = 0;
			else
				repeat_traversal = true;
		}
	}
	adaptivity_output_stream.push(adaptivity_request);
}

inline void K_o_nnb_backward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		K_e_bnn_backward(depth);
		K_e_non_backward(depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	CEdgeData &netupdate_local_hyp_edge_data = edge_comm_buffer->pop_returnRef();
	CEdgeData &netupdate_adjacent_hyp_edge_data = edge_comm_buffer->pop_returnRef();
	CEdgeData &netupdate_local_left_edge_data = edge_comm_buffer->pop_returnRef();
edge_comm_buffer->pop_returnRef();
	CEdgeData &netupdate_local_right_edge_data = edge_comm_buffer->pop_returnRef();
	CEdgeData &netupdate_adjacent_right_edge_data = edge_comm_buffer->pop_returnRef();
	edge_data_comm_right_edge_stack->push(netupdate_adjacent_hyp_edge_data);
	edge_data_comm_left_edge_stack->push(netupdate_adjacent_right_edge_data);
	unsigned char adaptivity_request = 
	cKernelClass.op_cell(depth, element_data, &netupdate_local_hyp_edge_data, &netupdate_local_right_edge_data, &netupdate_local_left_edge_data);
	assert(adaptivity_request == 0 || adaptivity_request == 68 || adaptivity_request == 50);
	if (adaptivity_request == 0)
	{}
	else	// speculative loading optimized for first if-branch
	{
		if (adaptivity_request == 68)		// refine
		{
			if (depth >= depth_limiter_max)
				adaptivity_request = 0;
			else
				repeat_traversal = true;
		}
 	else if (adaptivity_request == 50)	// coarsen
		{
			if (depth <= depth_limiter_min)
				adaptivity_request = 0;
			else
				repeat_traversal = true;
		}
	}
	adaptivity_output_stream.push(adaptivity_request);
}

inline void K_o_bnn_backward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		K_e_nbn_backward(depth);
		K_e_nob_backward(depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	CEdgeData &netupdate_local_hyp_edge_data = edge_comm_buffer->pop_returnRef();
edge_comm_buffer->pop_returnRef();
	CEdgeData &netupdate_local_left_edge_data = edge_comm_buffer->pop_returnRef();
	CEdgeData &netupdate_adjacent_left_edge_data = edge_comm_buffer->pop_returnRef();
	CEdgeData &netupdate_local_right_edge_data = edge_comm_buffer->pop_returnRef();
	CEdgeData &netupdate_adjacent_right_edge_data = edge_comm_buffer->pop_returnRef();
	edge_data_comm_left_edge_stack->push(netupdate_adjacent_left_edge_data);
	edge_data_comm_left_edge_stack->push(netupdate_adjacent_right_edge_data);
	unsigned char adaptivity_request = 
	cKernelClass.op_cell(depth, element_data, &netupdate_local_hyp_edge_data, &netupdate_local_right_edge_data, &netupdate_local_left_edge_data);
	assert(adaptivity_request == 0 || adaptivity_request == 68 || adaptivity_request == 50);
	if (adaptivity_request == 0)
	{}
	else	// speculative loading optimized for first if-branch
	{
		if (adaptivity_request == 68)		// refine
		{
			if (depth >= depth_limiter_max)
				adaptivity_request = 0;
			else
				repeat_traversal = true;
		}
 	else if (adaptivity_request == 50)	// coarsen
		{
			if (depth <= depth_limiter_min)
				adaptivity_request = 0;
			else
				repeat_traversal = true;
		}
	}
	adaptivity_output_stream.push(adaptivity_request);
}

inline void K_e_nbn_backward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		K_o_bnn_backward(depth);
		K_o_nno_backward(depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	CEdgeData &netupdate_local_hyp_edge_data = edge_comm_buffer->pop_returnRef();
	CEdgeData &netupdate_adjacent_hyp_edge_data = edge_comm_buffer->pop_returnRef();
	CEdgeData &netupdate_local_right_edge_data = edge_comm_buffer->pop_returnRef();
edge_comm_buffer->pop_returnRef();
	CEdgeData &netupdate_local_left_edge_data = edge_comm_buffer->pop_returnRef();
	CEdgeData &netupdate_adjacent_left_edge_data = edge_comm_buffer->pop_returnRef();
	edge_data_comm_left_edge_stack->push(netupdate_adjacent_hyp_edge_data);
	edge_data_comm_right_edge_stack->push(netupdate_adjacent_left_edge_data);
	unsigned char adaptivity_request = 
	cKernelClass.op_cell(depth, element_data, &netupdate_local_hyp_edge_data, &netupdate_local_right_edge_data, &netupdate_local_left_edge_data);
	assert(adaptivity_request == 0 || adaptivity_request == 68 || adaptivity_request == 50);
	if (adaptivity_request == 0)
	{}
	else	// speculative loading optimized for first if-branch
	{
		if (adaptivity_request == 68)		// refine
		{
			if (depth >= depth_limiter_max)
				adaptivity_request = 0;
			else
				repeat_traversal = true;
		}
 	else if (adaptivity_request == 50)	// coarsen
		{
			if (depth <= depth_limiter_min)
				adaptivity_request = 0;
			else
				repeat_traversal = true;
		}
	}
	adaptivity_output_stream.push(adaptivity_request);
}

inline void K_e_boo_backward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		K_o_onb_backward(depth);
		K_o_obo_backward(depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	CEdgeData &netupdate_local_hyp_edge_data = edge_comm_buffer->pop_returnRef();
edge_comm_buffer->pop_returnRef();
	CEdgeData netupdate_local_right_edge_data = edge_data_comm_right_edge_stack->pop_returnRef();
	CEdgeData netupdate_local_left_edge_data = edge_data_comm_right_edge_stack->pop_returnRef();
	unsigned char adaptivity_request = 
	cKernelClass.op_cell(depth, element_data, &netupdate_local_hyp_edge_data, &netupdate_local_right_edge_data, &netupdate_local_left_edge_data);
	assert(adaptivity_request == 0 || adaptivity_request == 68 || adaptivity_request == 50);
	if (adaptivity_request == 0)
	{}
	else	// speculative loading optimized for first if-branch
	{
		if (adaptivity_request == 68)		// refine
		{
			if (depth >= depth_limiter_max)
				adaptivity_request = 0;
			else
				repeat_traversal = true;
		}
 	else if (adaptivity_request == 50)	// coarsen
		{
			if (depth <= depth_limiter_min)
				adaptivity_request = 0;
			else
				repeat_traversal = true;
		}
	}
	adaptivity_output_stream.push(adaptivity_request);
}

inline void K_o_obo_backward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		K_e_oon_backward(depth);
		K_e_boo_backward(depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	CEdgeData netupdate_local_hyp_edge_data = edge_data_comm_right_edge_stack->pop_returnRef();
	CEdgeData netupdate_local_left_edge_data = edge_data_comm_left_edge_stack->pop_returnRef();
	CEdgeData &netupdate_local_right_edge_data = edge_comm_buffer->pop_returnRef();
edge_comm_buffer->pop_returnRef();
	unsigned char adaptivity_request = 
	cKernelClass.op_cell(depth, element_data, &netupdate_local_hyp_edge_data, &netupdate_local_right_edge_data, &netupdate_local_left_edge_data);
	assert(adaptivity_request == 0 || adaptivity_request == 68 || adaptivity_request == 50);
	if (adaptivity_request == 0)
	{}
	else	// speculative loading optimized for first if-branch
	{
		if (adaptivity_request == 68)		// refine
		{
			if (depth >= depth_limiter_max)
				adaptivity_request = 0;
			else
				repeat_traversal = true;
		}
 	else if (adaptivity_request == 50)	// coarsen
		{
			if (depth <= depth_limiter_min)
				adaptivity_request = 0;
			else
				repeat_traversal = true;
		}
	}
	adaptivity_output_stream.push(adaptivity_request);
}

inline void K_o_boo_backward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		K_e_obn_backward(depth);
		K_e_oob_backward(depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	CEdgeData &netupdate_local_hyp_edge_data = edge_comm_buffer->pop_returnRef();
edge_comm_buffer->pop_returnRef();
	CEdgeData netupdate_local_left_edge_data = edge_data_comm_left_edge_stack->pop_returnRef();
	CEdgeData netupdate_local_right_edge_data = edge_data_comm_left_edge_stack->pop_returnRef();
	unsigned char adaptivity_request = 
	cKernelClass.op_cell(depth, element_data, &netupdate_local_hyp_edge_data, &netupdate_local_right_edge_data, &netupdate_local_left_edge_data);
	assert(adaptivity_request == 0 || adaptivity_request == 68 || adaptivity_request == 50);
	if (adaptivity_request == 0)
	{}
	else	// speculative loading optimized for first if-branch
	{
		if (adaptivity_request == 68)		// refine
		{
			if (depth >= depth_limiter_max)
				adaptivity_request = 0;
			else
				repeat_traversal = true;
		}
 	else if (adaptivity_request == 50)	// coarsen
		{
			if (depth <= depth_limiter_min)
				adaptivity_request = 0;
			else
				repeat_traversal = true;
		}
	}
	adaptivity_output_stream.push(adaptivity_request);
}

inline void K_e_oob_backward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		K_o_ono_backward(depth);
		K_o_boo_backward(depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	CEdgeData netupdate_local_hyp_edge_data = edge_data_comm_left_edge_stack->pop_returnRef();
	CEdgeData netupdate_local_right_edge_data = edge_data_comm_right_edge_stack->pop_returnRef();
	CEdgeData &netupdate_local_left_edge_data = edge_comm_buffer->pop_returnRef();
edge_comm_buffer->pop_returnRef();
	unsigned char adaptivity_request = 
	cKernelClass.op_cell(depth, element_data, &netupdate_local_hyp_edge_data, &netupdate_local_right_edge_data, &netupdate_local_left_edge_data);
	assert(adaptivity_request == 0 || adaptivity_request == 68 || adaptivity_request == 50);
	if (adaptivity_request == 0)
	{}
	else	// speculative loading optimized for first if-branch
	{
		if (adaptivity_request == 68)		// refine
		{
			if (depth >= depth_limiter_max)
				adaptivity_request = 0;
			else
				repeat_traversal = true;
		}
 	else if (adaptivity_request == 50)	// coarsen
		{
			if (depth <= depth_limiter_min)
				adaptivity_request = 0;
			else
				repeat_traversal = true;
		}
	}
	adaptivity_output_stream.push(adaptivity_request);
}

inline void K_o_nbn_backward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		K_e_nnn_backward(depth);
		K_e_bon_backward(depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	CEdgeData &netupdate_local_hyp_edge_data = edge_comm_buffer->pop_returnRef();
	CEdgeData &netupdate_adjacent_hyp_edge_data = edge_comm_buffer->pop_returnRef();
	CEdgeData &netupdate_local_left_edge_data = edge_comm_buffer->pop_returnRef();
	CEdgeData &netupdate_adjacent_left_edge_data = edge_comm_buffer->pop_returnRef();
	CEdgeData &netupdate_local_right_edge_data = edge_comm_buffer->pop_returnRef();
edge_comm_buffer->pop_returnRef();
	edge_data_comm_right_edge_stack->push(netupdate_adjacent_hyp_edge_data);
	edge_data_comm_left_edge_stack->push(netupdate_adjacent_left_edge_data);
	unsigned char adaptivity_request = 
	cKernelClass.op_cell(depth, element_data, &netupdate_local_hyp_edge_data, &netupdate_local_right_edge_data, &netupdate_local_left_edge_data);
	assert(adaptivity_request == 0 || adaptivity_request == 68 || adaptivity_request == 50);
	if (adaptivity_request == 0)
	{}
	else	// speculative loading optimized for first if-branch
	{
		if (adaptivity_request == 68)		// refine
		{
			if (depth >= depth_limiter_max)
				adaptivity_request = 0;
			else
				repeat_traversal = true;
		}
 	else if (adaptivity_request == 50)	// coarsen
		{
			if (depth <= depth_limiter_min)
				adaptivity_request = 0;
			else
				repeat_traversal = true;
		}
	}
	adaptivity_output_stream.push(adaptivity_request);
}

inline void K_e_obo_backward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		K_o_bno_backward(depth);
		K_o_ooo_backward(depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	CEdgeData netupdate_local_hyp_edge_data = edge_data_comm_left_edge_stack->pop_returnRef();
	CEdgeData netupdate_local_left_edge_data = edge_data_comm_right_edge_stack->pop_returnRef();
	CEdgeData &netupdate_local_right_edge_data = edge_comm_buffer->pop_returnRef();
edge_comm_buffer->pop_returnRef();
	unsigned char adaptivity_request = 
	cKernelClass.op_cell(depth, element_data, &netupdate_local_hyp_edge_data, &netupdate_local_right_edge_data, &netupdate_local_left_edge_data);
	assert(adaptivity_request == 0 || adaptivity_request == 68 || adaptivity_request == 50);
	if (adaptivity_request == 0)
	{}
	else	// speculative loading optimized for first if-branch
	{
		if (adaptivity_request == 68)		// refine
		{
			if (depth >= depth_limiter_max)
				adaptivity_request = 0;
			else
				repeat_traversal = true;
		}
 	else if (adaptivity_request == 50)	// coarsen
		{
			if (depth <= depth_limiter_min)
				adaptivity_request = 0;
			else
				repeat_traversal = true;
		}
	}
	adaptivity_output_stream.push(adaptivity_request);
}

inline void K_e_nnb_backward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		K_o_nnn_backward(depth);
		K_o_bno_backward(depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	CEdgeData &netupdate_local_hyp_edge_data = edge_comm_buffer->pop_returnRef();
	CEdgeData &netupdate_adjacent_hyp_edge_data = edge_comm_buffer->pop_returnRef();
	CEdgeData &netupdate_local_right_edge_data = edge_comm_buffer->pop_returnRef();
	CEdgeData &netupdate_adjacent_right_edge_data = edge_comm_buffer->pop_returnRef();
	CEdgeData &netupdate_local_left_edge_data = edge_comm_buffer->pop_returnRef();
edge_comm_buffer->pop_returnRef();
	edge_data_comm_left_edge_stack->push(netupdate_adjacent_hyp_edge_data);
	edge_data_comm_right_edge_stack->push(netupdate_adjacent_right_edge_data);
	unsigned char adaptivity_request = 
	cKernelClass.op_cell(depth, element_data, &netupdate_local_hyp_edge_data, &netupdate_local_right_edge_data, &netupdate_local_left_edge_data);
	assert(adaptivity_request == 0 || adaptivity_request == 68 || adaptivity_request == 50);
	if (adaptivity_request == 0)
	{}
	else	// speculative loading optimized for first if-branch
	{
		if (adaptivity_request == 68)		// refine
		{
			if (depth >= depth_limiter_max)
				adaptivity_request = 0;
			else
				repeat_traversal = true;
		}
 	else if (adaptivity_request == 50)	// coarsen
		{
			if (depth <= depth_limiter_min)
				adaptivity_request = 0;
			else
				repeat_traversal = true;
		}
	}
	adaptivity_output_stream.push(adaptivity_request);
}

inline void K_o_oob_backward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		K_e_bon_backward(depth);
		K_e_ooo_backward(depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	CEdgeData netupdate_local_hyp_edge_data = edge_data_comm_right_edge_stack->pop_returnRef();
	CEdgeData netupdate_local_right_edge_data = edge_data_comm_left_edge_stack->pop_returnRef();
	CEdgeData &netupdate_local_left_edge_data = edge_comm_buffer->pop_returnRef();
edge_comm_buffer->pop_returnRef();
	unsigned char adaptivity_request = 
	cKernelClass.op_cell(depth, element_data, &netupdate_local_hyp_edge_data, &netupdate_local_right_edge_data, &netupdate_local_left_edge_data);
	assert(adaptivity_request == 0 || adaptivity_request == 68 || adaptivity_request == 50);
	if (adaptivity_request == 0)
	{}
	else	// speculative loading optimized for first if-branch
	{
		if (adaptivity_request == 68)		// refine
		{
			if (depth >= depth_limiter_max)
				adaptivity_request = 0;
			else
				repeat_traversal = true;
		}
 	else if (adaptivity_request == 50)	// coarsen
		{
			if (depth <= depth_limiter_min)
				adaptivity_request = 0;
			else
				repeat_traversal = true;
		}
	}
	adaptivity_output_stream.push(adaptivity_request);
}

inline void K_o_bbn_backward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		K_e_nbn_backward(depth);
		K_e_bob_backward(depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	CEdgeData &netupdate_local_hyp_edge_data = edge_comm_buffer->pop_returnRef();
edge_comm_buffer->pop_returnRef();
	CEdgeData &netupdate_local_left_edge_data = edge_comm_buffer->pop_returnRef();
	CEdgeData &netupdate_adjacent_left_edge_data = edge_comm_buffer->pop_returnRef();
	CEdgeData &netupdate_local_right_edge_data = edge_comm_buffer->pop_returnRef();
edge_comm_buffer->pop_returnRef();
	edge_data_comm_left_edge_stack->push(netupdate_adjacent_left_edge_data);
	unsigned char adaptivity_request = 
	cKernelClass.op_cell(depth, element_data, &netupdate_local_hyp_edge_data, &netupdate_local_right_edge_data, &netupdate_local_left_edge_data);
	assert(adaptivity_request == 0 || adaptivity_request == 68 || adaptivity_request == 50);
	if (adaptivity_request == 0)
	{}
	else	// speculative loading optimized for first if-branch
	{
		if (adaptivity_request == 68)		// refine
		{
			if (depth >= depth_limiter_max)
				adaptivity_request = 0;
			else
				repeat_traversal = true;
		}
 	else if (adaptivity_request == 50)	// coarsen
		{
			if (depth <= depth_limiter_min)
				adaptivity_request = 0;
			else
				repeat_traversal = true;
		}
	}
	adaptivity_output_stream.push(adaptivity_request);
}

inline void K_e_bbo_backward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		K_o_bnb_backward(depth);
		K_o_obo_backward(depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	CEdgeData &netupdate_local_hyp_edge_data = edge_comm_buffer->pop_returnRef();
edge_comm_buffer->pop_returnRef();
	CEdgeData netupdate_local_left_edge_data = edge_data_comm_right_edge_stack->pop_returnRef();
	CEdgeData &netupdate_local_right_edge_data = edge_comm_buffer->pop_returnRef();
edge_comm_buffer->pop_returnRef();
	unsigned char adaptivity_request = 
	cKernelClass.op_cell(depth, element_data, &netupdate_local_hyp_edge_data, &netupdate_local_right_edge_data, &netupdate_local_left_edge_data);
	assert(adaptivity_request == 0 || adaptivity_request == 68 || adaptivity_request == 50);
	if (adaptivity_request == 0)
	{}
	else	// speculative loading optimized for first if-branch
	{
		if (adaptivity_request == 68)		// refine
		{
			if (depth >= depth_limiter_max)
				adaptivity_request = 0;
			else
				repeat_traversal = true;
		}
 	else if (adaptivity_request == 50)	// coarsen
		{
			if (depth <= depth_limiter_min)
				adaptivity_request = 0;
			else
				repeat_traversal = true;
		}
	}
	adaptivity_output_stream.push(adaptivity_request);
}

inline void K_e_nbb_backward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		K_o_bnn_backward(depth);
		K_o_bno_backward(depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	CEdgeData &netupdate_local_hyp_edge_data = edge_comm_buffer->pop_returnRef();
	CEdgeData &netupdate_adjacent_hyp_edge_data = edge_comm_buffer->pop_returnRef();
	CEdgeData &netupdate_local_right_edge_data = edge_comm_buffer->pop_returnRef();
edge_comm_buffer->pop_returnRef();
	CEdgeData &netupdate_local_left_edge_data = edge_comm_buffer->pop_returnRef();
edge_comm_buffer->pop_returnRef();
	edge_data_comm_left_edge_stack->push(netupdate_adjacent_hyp_edge_data);
	unsigned char adaptivity_request = 
	cKernelClass.op_cell(depth, element_data, &netupdate_local_hyp_edge_data, &netupdate_local_right_edge_data, &netupdate_local_left_edge_data);
	assert(adaptivity_request == 0 || adaptivity_request == 68 || adaptivity_request == 50);
	if (adaptivity_request == 0)
	{}
	else	// speculative loading optimized for first if-branch
	{
		if (adaptivity_request == 68)		// refine
		{
			if (depth >= depth_limiter_max)
				adaptivity_request = 0;
			else
				repeat_traversal = true;
		}
 	else if (adaptivity_request == 50)	// coarsen
		{
			if (depth <= depth_limiter_min)
				adaptivity_request = 0;
			else
				repeat_traversal = true;
		}
	}
	adaptivity_output_stream.push(adaptivity_request);
}

inline void K_o_nbb_backward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		K_e_bnn_backward(depth);
		K_e_bon_backward(depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	CEdgeData &netupdate_local_hyp_edge_data = edge_comm_buffer->pop_returnRef();
	CEdgeData &netupdate_adjacent_hyp_edge_data = edge_comm_buffer->pop_returnRef();
	CEdgeData &netupdate_local_left_edge_data = edge_comm_buffer->pop_returnRef();
edge_comm_buffer->pop_returnRef();
	CEdgeData &netupdate_local_right_edge_data = edge_comm_buffer->pop_returnRef();
edge_comm_buffer->pop_returnRef();
	edge_data_comm_right_edge_stack->push(netupdate_adjacent_hyp_edge_data);
	unsigned char adaptivity_request = 
	cKernelClass.op_cell(depth, element_data, &netupdate_local_hyp_edge_data, &netupdate_local_right_edge_data, &netupdate_local_left_edge_data);
	assert(adaptivity_request == 0 || adaptivity_request == 68 || adaptivity_request == 50);
	if (adaptivity_request == 0)
	{}
	else	// speculative loading optimized for first if-branch
	{
		if (adaptivity_request == 68)		// refine
		{
			if (depth >= depth_limiter_max)
				adaptivity_request = 0;
			else
				repeat_traversal = true;
		}
 	else if (adaptivity_request == 50)	// coarsen
		{
			if (depth <= depth_limiter_min)
				adaptivity_request = 0;
			else
				repeat_traversal = true;
		}
	}
	adaptivity_output_stream.push(adaptivity_request);
}

inline void K_e_obb_backward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		K_o_bno_backward(depth);
		K_o_boo_backward(depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	CEdgeData netupdate_local_hyp_edge_data = edge_data_comm_left_edge_stack->pop_returnRef();
	CEdgeData &netupdate_local_right_edge_data = edge_comm_buffer->pop_returnRef();
edge_comm_buffer->pop_returnRef();
	CEdgeData &netupdate_local_left_edge_data = edge_comm_buffer->pop_returnRef();
edge_comm_buffer->pop_returnRef();
	unsigned char adaptivity_request = 
	cKernelClass.op_cell(depth, element_data, &netupdate_local_hyp_edge_data, &netupdate_local_right_edge_data, &netupdate_local_left_edge_data);
	assert(adaptivity_request == 0 || adaptivity_request == 68 || adaptivity_request == 50);
	if (adaptivity_request == 0)
	{}
	else	// speculative loading optimized for first if-branch
	{
		if (adaptivity_request == 68)		// refine
		{
			if (depth >= depth_limiter_max)
				adaptivity_request = 0;
			else
				repeat_traversal = true;
		}
 	else if (adaptivity_request == 50)	// coarsen
		{
			if (depth <= depth_limiter_min)
				adaptivity_request = 0;
			else
				repeat_traversal = true;
		}
	}
	adaptivity_output_stream.push(adaptivity_request);
}

inline void K_o_obb_backward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		K_e_bon_backward(depth);
		K_e_boo_backward(depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	CEdgeData netupdate_local_hyp_edge_data = edge_data_comm_right_edge_stack->pop_returnRef();
	CEdgeData &netupdate_local_left_edge_data = edge_comm_buffer->pop_returnRef();
edge_comm_buffer->pop_returnRef();
	CEdgeData &netupdate_local_right_edge_data = edge_comm_buffer->pop_returnRef();
edge_comm_buffer->pop_returnRef();
	unsigned char adaptivity_request = 
	cKernelClass.op_cell(depth, element_data, &netupdate_local_hyp_edge_data, &netupdate_local_right_edge_data, &netupdate_local_left_edge_data);
	assert(adaptivity_request == 0 || adaptivity_request == 68 || adaptivity_request == 50);
	if (adaptivity_request == 0)
	{}
	else	// speculative loading optimized for first if-branch
	{
		if (adaptivity_request == 68)		// refine
		{
			if (depth >= depth_limiter_max)
				adaptivity_request = 0;
			else
				repeat_traversal = true;
		}
 	else if (adaptivity_request == 50)	// coarsen
		{
			if (depth <= depth_limiter_min)
				adaptivity_request = 0;
			else
				repeat_traversal = true;
		}
	}
	adaptivity_output_stream.push(adaptivity_request);
}

inline void K_e_bnb_backward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		K_o_nnb_backward(depth);
		K_o_bbo_backward(depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	CEdgeData &netupdate_local_hyp_edge_data = edge_comm_buffer->pop_returnRef();
edge_comm_buffer->pop_returnRef();
	CEdgeData &netupdate_local_right_edge_data = edge_comm_buffer->pop_returnRef();
	CEdgeData &netupdate_adjacent_right_edge_data = edge_comm_buffer->pop_returnRef();
	CEdgeData &netupdate_local_left_edge_data = edge_comm_buffer->pop_returnRef();
edge_comm_buffer->pop_returnRef();
	edge_data_comm_right_edge_stack->push(netupdate_adjacent_right_edge_data);
	unsigned char adaptivity_request = 
	cKernelClass.op_cell(depth, element_data, &netupdate_local_hyp_edge_data, &netupdate_local_right_edge_data, &netupdate_local_left_edge_data);
	assert(adaptivity_request == 0 || adaptivity_request == 68 || adaptivity_request == 50);
	if (adaptivity_request == 0)
	{}
	else	// speculative loading optimized for first if-branch
	{
		if (adaptivity_request == 68)		// refine
		{
			if (depth >= depth_limiter_max)
				adaptivity_request = 0;
			else
				repeat_traversal = true;
		}
 	else if (adaptivity_request == 50)	// coarsen
		{
			if (depth <= depth_limiter_min)
				adaptivity_request = 0;
			else
				repeat_traversal = true;
		}
	}
	adaptivity_output_stream.push(adaptivity_request);
}

inline void K_o_bob_backward(int depth)
{

	if (structure_lifo_in.getNextData())
	{
		depth++;
		K_e_bbn_backward(depth);
		K_e_oob_backward(depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	CEdgeData &netupdate_local_hyp_edge_data = edge_comm_buffer->pop_returnRef();
edge_comm_buffer->pop_returnRef();
	CEdgeData netupdate_local_right_edge_data = edge_data_comm_left_edge_stack->pop_returnRef();
	CEdgeData &netupdate_local_left_edge_data = edge_comm_buffer->pop_returnRef();
edge_comm_buffer->pop_returnRef();
	unsigned char adaptivity_request = 
	cKernelClass.op_cell(depth, element_data, &netupdate_local_hyp_edge_data, &netupdate_local_right_edge_data, &netupdate_local_left_edge_data);
	assert(adaptivity_request == 0 || adaptivity_request == 68 || adaptivity_request == 50);
	if (adaptivity_request == 0)
	{}
	else	// speculative loading optimized for first if-branch
	{
		if (adaptivity_request == 68)		// refine
		{
			if (depth >= depth_limiter_max)
				adaptivity_request = 0;
			else
				repeat_traversal = true;
		}
 	else if (adaptivity_request == 50)	// coarsen
		{
			if (depth <= depth_limiter_min)
				adaptivity_request = 0;
			else
				repeat_traversal = true;
		}
	}
	adaptivity_output_stream.push(adaptivity_request);
}

static const int number_of_recursion_functions = 88;
typedef void (TThisClass::*TRecursiveMethod)(int);
enum ESFCMethod{
	SFC_METHOD_DEFAULT = 0,
	SFC_METHOD_FORCE_FORWARD = (1 << 0),
	SFC_METHOD_FORCE_BACKWARD = (1 << 1),
	SFC_METHOD_NEW_TO_OLD_EDGE_TYPES = (1 << 2),
	SFC_METHOD_OLD_TO_NEW_EDGE_TYPES = (1 << 3),
	SFC_METHOD_LIMITER___ = (1 << 4)
};

template <int specialMode = 0>
TRecursiveMethod getSFCMethod(CTriangle_Factory &i_cTriangleFactory)
{
	static TRecursiveMethod methodArray [2] [27] [2] =
	{
	{
	{
		&TThisClass::K_e_nnn_forward ,
		&TThisClass::K_e_nnn_backward 
	} ,
	{
		&TThisClass::K_e_nno_forward ,
		nullptr 
	} ,
	{
		&TThisClass::K_e_nnb_forward ,
		&TThisClass::K_e_nnb_backward 
	} ,
	{
		nullptr ,
		&TThisClass::K_e_non_backward 
	} ,
	{
		&TThisClass::K_e_noo_forward ,
		&TThisClass::K_e_noo_backward 
	} ,
	{
		nullptr ,
		&TThisClass::K_e_nob_backward 
	} ,
	{
		&TThisClass::K_e_nbn_forward ,
		&TThisClass::K_e_nbn_backward 
	} ,
	{
		&TThisClass::K_e_nbo_forward ,
		nullptr 
	} ,
	{
		&TThisClass::K_e_nbb_forward ,
		&TThisClass::K_e_nbb_backward 
	} ,
	{
		&TThisClass::K_e_onn_forward ,
		&TThisClass::K_e_onn_backward 
	} ,
	{
		&TThisClass::K_e_ono_forward ,
		nullptr 
	} ,
	{
		&TThisClass::K_e_onb_forward ,
		nullptr 
	} ,
	{
		nullptr ,
		&TThisClass::K_e_oon_backward 
	} ,
	{
		&TThisClass::K_e_ooo_forward ,
		&TThisClass::K_e_ooo_backward 
	} ,
	{
		&TThisClass::K_e_oob_forward ,
		&TThisClass::K_e_oob_backward 
	} ,
	{
		nullptr ,
		&TThisClass::K_e_obn_backward 
	} ,
	{
		&TThisClass::K_e_obo_forward ,
		&TThisClass::K_e_obo_backward 
	} ,
	{
		&TThisClass::K_e_obb_forward ,
		&TThisClass::K_e_obb_backward 
	} ,
	{
		&TThisClass::K_e_bnn_forward ,
		&TThisClass::K_e_bnn_backward 
	} ,
	{
		&TThisClass::K_e_bno_forward ,
		nullptr 
	} ,
	{
		&TThisClass::K_e_bnb_forward ,
		&TThisClass::K_e_bnb_backward 
	} ,
	{
		nullptr ,
		&TThisClass::K_e_bon_backward 
	} ,
	{
		&TThisClass::K_e_boo_forward ,
		&TThisClass::K_e_boo_backward 
	} ,
	{
		&TThisClass::K_e_bob_forward ,
		&TThisClass::K_e_bob_backward 
	} ,
	{
		&TThisClass::K_e_bbn_forward ,
		&TThisClass::K_e_bbn_backward 
	} ,
	{
		&TThisClass::K_e_bbo_forward ,
		&TThisClass::K_e_bbo_backward 
	} ,
	{
		&TThisClass::K_e_bbb_forward ,
		&TThisClass::K_e_bbb_backward 
	} 
	} ,
	{
	{
		&TThisClass::K_o_nnn_forward ,
		&TThisClass::K_o_nnn_backward 
	} ,
	{
		nullptr ,
		&TThisClass::K_o_nno_backward 
	} ,
	{
		&TThisClass::K_o_nnb_forward ,
		&TThisClass::K_o_nnb_backward 
	} ,
	{
		&TThisClass::K_o_non_forward ,
		nullptr 
	} ,
	{
		&TThisClass::K_o_noo_forward ,
		&TThisClass::K_o_noo_backward 
	} ,
	{
		&TThisClass::K_o_nob_forward ,
		nullptr 
	} ,
	{
		&TThisClass::K_o_nbn_forward ,
		&TThisClass::K_o_nbn_backward 
	} ,
	{
		nullptr ,
		&TThisClass::K_o_nbo_backward 
	} ,
	{
		&TThisClass::K_o_nbb_forward ,
		&TThisClass::K_o_nbb_backward 
	} ,
	{
		&TThisClass::K_o_onn_forward ,
		&TThisClass::K_o_onn_backward 
	} ,
	{
		nullptr ,
		&TThisClass::K_o_ono_backward 
	} ,
	{
		nullptr ,
		&TThisClass::K_o_onb_backward 
	} ,
	{
		&TThisClass::K_o_oon_forward ,
		nullptr 
	} ,
	{
		&TThisClass::K_o_ooo_forward ,
		&TThisClass::K_o_ooo_backward 
	} ,
	{
		&TThisClass::K_o_oob_forward ,
		&TThisClass::K_o_oob_backward 
	} ,
	{
		&TThisClass::K_o_obn_forward ,
		nullptr 
	} ,
	{
		&TThisClass::K_o_obo_forward ,
		&TThisClass::K_o_obo_backward 
	} ,
	{
		&TThisClass::K_o_obb_forward ,
		&TThisClass::K_o_obb_backward 
	} ,
	{
		&TThisClass::K_o_bnn_forward ,
		&TThisClass::K_o_bnn_backward 
	} ,
	{
		nullptr ,
		&TThisClass::K_o_bno_backward 
	} ,
	{
		&TThisClass::K_o_bnb_forward ,
		&TThisClass::K_o_bnb_backward 
	} ,
	{
		&TThisClass::K_o_bon_forward ,
		nullptr 
	} ,
	{
		&TThisClass::K_o_boo_forward ,
		&TThisClass::K_o_boo_backward 
	} ,
	{
		&TThisClass::K_o_bob_forward ,
		&TThisClass::K_o_bob_backward 
	} ,
	{
		&TThisClass::K_o_bbn_forward ,
		&TThisClass::K_o_bbn_backward 
	} ,
	{
		&TThisClass::K_o_bbo_forward ,
		&TThisClass::K_o_bbo_backward 
	} ,
	{
		&TThisClass::K_o_bbb_forward ,
		&TThisClass::K_o_bbb_backward 
	} 
	} 
	} 	;

	assert(i_cTriangleFactory.triangleType != CTriangle_Enums::TRIANGLE_TYPE_INVALID);
	assert(i_cTriangleFactory.evenOdd != CTriangle_Enums::EVEN_ODD_INVALID);

		assert(i_cTriangleFactory.edgeTypes.hyp != CTriangle_Enums::EDGE_TYPE_INVALID);
		assert(i_cTriangleFactory.edgeTypes.left != CTriangle_Enums::EDGE_TYPE_INVALID);
		assert(i_cTriangleFactory.edgeTypes.right != CTriangle_Enums::EDGE_TYPE_INVALID);
		CTriangle_Enums::EEdgeType hyp, left, right;
		if (specialMode == 0)
		{
			hyp = i_cTriangleFactory.edgeTypes.hyp;
			right = i_cTriangleFactory.edgeTypes.right;
			left = i_cTriangleFactory.edgeTypes.left;
		}
		else if (specialMode & SFC_METHOD_NEW_TO_OLD_EDGE_TYPES)
		{
			hyp = (i_cTriangleFactory.edgeTypes.hyp == CTriangle_Enums::EDGE_TYPE_NEW ? CTriangle_Enums::EDGE_TYPE_OLD : i_cTriangleFactory.edgeTypes.hyp);
			right = (i_cTriangleFactory.edgeTypes.right == CTriangle_Enums::EDGE_TYPE_NEW ? CTriangle_Enums::EDGE_TYPE_OLD : i_cTriangleFactory.edgeTypes.right);
			left = (i_cTriangleFactory.edgeTypes.left == CTriangle_Enums::EDGE_TYPE_NEW ? CTriangle_Enums::EDGE_TYPE_OLD : i_cTriangleFactory.edgeTypes.left);
		}
		else if (specialMode & SFC_METHOD_OLD_TO_NEW_EDGE_TYPES)
		{
			hyp = (i_cTriangleFactory.edgeTypes.hyp == CTriangle_Enums::EDGE_TYPE_OLD ? CTriangle_Enums::EDGE_TYPE_NEW : i_cTriangleFactory.edgeTypes.hyp);
			right = (i_cTriangleFactory.edgeTypes.right == CTriangle_Enums::EDGE_TYPE_OLD ? CTriangle_Enums::EDGE_TYPE_NEW : i_cTriangleFactory.edgeTypes.right);
			left = (i_cTriangleFactory.edgeTypes.left == CTriangle_Enums::EDGE_TYPE_OLD ? CTriangle_Enums::EDGE_TYPE_NEW : i_cTriangleFactory.edgeTypes.left);
		}
	#if DEBUG
		else
		{
			assert(false);
		}
	#endif
	CTriangle_Enums::EDirection direction;
	if (specialMode & SFC_METHOD_FORCE_FORWARD)
	{
		direction = CTriangle_Enums::DIRECTION_FORWARD;
	}
	else if (specialMode & SFC_METHOD_FORCE_BACKWARD)
	{
		direction = CTriangle_Enums::DIRECTION_BACKWARD;
	}
	else
	{
		direction = i_cTriangleFactory.traversalDirection;
	}

		assert(i_cTriangleFactory.traversalDirection != CTriangle_Enums::DIRECTION_INVALID);
	assert(i_cTriangleFactory.hypNormal != CTriangle_Enums::NORMAL_INVALID);
#if DEBUG
	assert(methodArray[i_cTriangleFactory.evenOdd][hyp*9+right*3+left][direction] != nullptr);
#endif
	return methodArray[i_cTriangleFactory.evenOdd][hyp*9+right*3+left][direction];
}
