
/*
 * Copyright (C) 2011 Technische Universitaet Muenchen
 * This file is part of the Sierpinski project. For conditions of distribution and
 * use, please see the copyright notice in the file 'copyright.txt' at the root
 * directory of this package and the copyright notice at http://www5.in.tum.de/sierpinski
 *
 * This file was automatically generated by the sierpinski code generator
 */


inline void K_e_bbb_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		V_o_bnb_backward(vx1, vy1, vx2, vy2, mx, my, depth);
		H_o_bbo_backward(vx2, vy2, vx0, vy0, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_lifo.getNextDataPtr();
}

inline void V_o_bnb_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		K_e_bbn_backward(vx2, vy2, vx0, vy0, mx, my, depth);
		H_e_nob_backward(vx1, vy1, vx2, vy2, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_lifo.getNextDataPtr();
}

inline void K_e_bbn_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		V_o_bnb_backward(vx1, vy1, vx2, vy2, mx, my, depth);
		H_o_nbo_backward(vx2, vy2, vx0, vy0, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_lifo.getNextDataPtr();
}

inline void H_o_nbo_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		K_e_onn_backward(vx2, vy2, vx0, vy0, mx, my, depth);
		V_e_bon_backward(vx1, vy1, vx2, vy2, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_lifo.getNextDataPtr();
}

inline void K_e_onn_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		V_o_nno_backward(vx1, vy1, vx2, vy2, mx, my, depth);
		H_o_noo_backward(vx2, vy2, vx0, vy0, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_lifo.getNextDataPtr();
}

inline void V_o_nno_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		K_e_onn_backward(vx2, vy2, vx0, vy0, mx, my, depth);
		H_e_non_backward(vx1, vy1, vx2, vy2, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_lifo.getNextDataPtr();
}

inline void H_e_non_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		K_o_onn_backward(vx1, vy1, vx2, vy2, mx, my, depth);
		V_o_nno_backward(vx2, vy2, vx0, vy0, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_lifo.getNextDataPtr();
}

inline void K_o_onn_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		V_e_non_backward(vx2, vy2, vx0, vy0, mx, my, depth);
		H_e_noo_backward(vx1, vy1, vx2, vy2, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_lifo.getNextDataPtr();
}

inline void V_e_non_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		K_o_onn_backward(vx1, vy1, vx2, vy2, mx, my, depth);
		H_o_nno_backward(vx2, vy2, vx0, vy0, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_lifo.getNextDataPtr();
}

inline void H_o_nno_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		K_e_onn_backward(vx2, vy2, vx0, vy0, mx, my, depth);
		V_e_non_backward(vx1, vy1, vx2, vy2, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_lifo.getNextDataPtr();
}

inline void H_e_noo_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		K_o_onn_backward(vx1, vy1, vx2, vy2, mx, my, depth);
		V_o_ono_backward(vx2, vy2, vx0, vy0, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_lifo.getNextDataPtr();
}

inline void V_o_ono_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		K_e_oon_backward(vx2, vy2, vx0, vy0, mx, my, depth);
		H_e_noo_backward(vx1, vy1, vx2, vy2, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_lifo.getNextDataPtr();
}

inline void K_e_oon_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		V_o_ono_backward(vx1, vy1, vx2, vy2, mx, my, depth);
		H_o_noo_backward(vx2, vy2, vx0, vy0, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_lifo.getNextDataPtr();
}

inline void H_o_noo_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		K_e_onn_backward(vx2, vy2, vx0, vy0, mx, my, depth);
		V_e_oon_backward(vx1, vy1, vx2, vy2, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_lifo.getNextDataPtr();
}

inline void V_e_oon_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		K_o_ono_backward(vx1, vy1, vx2, vy2, mx, my, depth);
		H_o_noo_backward(vx2, vy2, vx0, vy0, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_lifo.getNextDataPtr();
}

inline void K_o_ono_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		V_e_oon_backward(vx2, vy2, vx0, vy0, mx, my, depth);
		H_e_noo_backward(vx1, vy1, vx2, vy2, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_lifo.getNextDataPtr();
}

inline void V_e_bon_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		K_o_onb_backward(vx1, vy1, vx2, vy2, mx, my, depth);
		H_o_nbo_backward(vx2, vy2, vx0, vy0, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_lifo.getNextDataPtr();
}

inline void K_o_onb_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		V_e_bon_backward(vx2, vy2, vx0, vy0, mx, my, depth);
		H_e_noo_backward(vx1, vy1, vx2, vy2, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_lifo.getNextDataPtr();
}

inline void H_e_nob_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		K_o_onn_backward(vx1, vy1, vx2, vy2, mx, my, depth);
		V_o_bno_backward(vx2, vy2, vx0, vy0, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_lifo.getNextDataPtr();
}

inline void V_o_bno_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		K_e_obn_backward(vx2, vy2, vx0, vy0, mx, my, depth);
		H_e_nob_backward(vx1, vy1, vx2, vy2, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_lifo.getNextDataPtr();
}

inline void K_e_obn_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		V_o_bno_backward(vx1, vy1, vx2, vy2, mx, my, depth);
		H_o_noo_backward(vx2, vy2, vx0, vy0, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_lifo.getNextDataPtr();
}

inline void H_o_bbo_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		K_e_obn_backward(vx2, vy2, vx0, vy0, mx, my, depth);
		V_e_bob_backward(vx1, vy1, vx2, vy2, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_lifo.getNextDataPtr();
}

inline void V_e_bob_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		K_o_onb_backward(vx1, vy1, vx2, vy2, mx, my, depth);
		H_o_bbo_backward(vx2, vy2, vx0, vy0, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_lifo.getNextDataPtr();
}

inline void K_o_bbb_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		V_e_bbn_backward(vx2, vy2, vx0, vy0, mx, my, depth);
		H_e_bob_backward(vx1, vy1, vx2, vy2, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_lifo.getNextDataPtr();
}

inline void V_e_bbn_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		K_o_bnb_backward(vx1, vy1, vx2, vy2, mx, my, depth);
		H_o_nbo_backward(vx2, vy2, vx0, vy0, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_lifo.getNextDataPtr();
}

inline void K_o_bnb_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		V_e_bbn_backward(vx2, vy2, vx0, vy0, mx, my, depth);
		H_e_nob_backward(vx1, vy1, vx2, vy2, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_lifo.getNextDataPtr();
}

inline void H_e_bob_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		K_o_onb_backward(vx1, vy1, vx2, vy2, mx, my, depth);
		V_o_bbo_backward(vx2, vy2, vx0, vy0, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_lifo.getNextDataPtr();
}

inline void V_o_bbo_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		K_e_obn_backward(vx2, vy2, vx0, vy0, mx, my, depth);
		H_e_bob_backward(vx1, vy1, vx2, vy2, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_lifo.getNextDataPtr();
}

inline void K_e_nnn_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		V_o_nnn_backward(vx1, vy1, vx2, vy2, mx, my, depth);
		H_o_nno_backward(vx2, vy2, vx0, vy0, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_lifo.getNextDataPtr();
}

inline void V_o_nnn_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		K_e_nnn_backward(vx2, vy2, vx0, vy0, mx, my, depth);
		H_e_non_backward(vx1, vy1, vx2, vy2, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_lifo.getNextDataPtr();
}

inline void K_o_nnn_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		V_e_nnn_backward(vx2, vy2, vx0, vy0, mx, my, depth);
		H_e_non_backward(vx1, vy1, vx2, vy2, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_lifo.getNextDataPtr();
}

inline void V_e_nnn_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		K_o_nnn_backward(vx1, vy1, vx2, vy2, mx, my, depth);
		H_o_nno_backward(vx2, vy2, vx0, vy0, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_lifo.getNextDataPtr();
}

inline void K_e_ooo_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		V_o_ono_backward(vx1, vy1, vx2, vy2, mx, my, depth);
		H_o_ooo_backward(vx2, vy2, vx0, vy0, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_lifo.getNextDataPtr();
}

inline void H_o_ooo_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		K_e_oon_backward(vx2, vy2, vx0, vy0, mx, my, depth);
		V_e_ooo_backward(vx1, vy1, vx2, vy2, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_lifo.getNextDataPtr();
}

inline void V_e_ooo_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		K_o_ono_backward(vx1, vy1, vx2, vy2, mx, my, depth);
		H_o_ooo_backward(vx2, vy2, vx0, vy0, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_lifo.getNextDataPtr();
}

inline void K_o_ooo_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		V_e_oon_backward(vx2, vy2, vx0, vy0, mx, my, depth);
		H_e_ooo_backward(vx1, vy1, vx2, vy2, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_lifo.getNextDataPtr();
}

inline void H_e_ooo_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		K_o_ono_backward(vx1, vy1, vx2, vy2, mx, my, depth);
		V_o_ooo_backward(vx2, vy2, vx0, vy0, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_lifo.getNextDataPtr();
}

inline void V_o_ooo_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		K_e_oon_backward(vx2, vy2, vx0, vy0, mx, my, depth);
		H_e_ooo_backward(vx1, vy1, vx2, vy2, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_lifo.getNextDataPtr();
}

inline void K_e_bnn_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		V_o_nnb_backward(vx1, vy1, vx2, vy2, mx, my, depth);
		H_o_nbo_backward(vx2, vy2, vx0, vy0, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_lifo.getNextDataPtr();
}

inline void V_o_nnb_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		K_e_bnn_backward(vx2, vy2, vx0, vy0, mx, my, depth);
		H_e_non_backward(vx1, vy1, vx2, vy2, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_lifo.getNextDataPtr();
}

inline void K_o_bnn_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		V_e_nbn_backward(vx2, vy2, vx0, vy0, mx, my, depth);
		H_e_nob_backward(vx1, vy1, vx2, vy2, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_lifo.getNextDataPtr();
}

inline void V_e_nbn_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		K_o_bnn_backward(vx1, vy1, vx2, vy2, mx, my, depth);
		H_o_nno_backward(vx2, vy2, vx0, vy0, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_lifo.getNextDataPtr();
}

inline void K_e_boo_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		V_o_onb_backward(vx1, vy1, vx2, vy2, mx, my, depth);
		H_o_obo_backward(vx2, vy2, vx0, vy0, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_lifo.getNextDataPtr();
}

inline void V_o_onb_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		K_e_bon_backward(vx2, vy2, vx0, vy0, mx, my, depth);
		H_e_noo_backward(vx1, vy1, vx2, vy2, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_lifo.getNextDataPtr();
}

inline void K_e_bon_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		V_o_onb_backward(vx1, vy1, vx2, vy2, mx, my, depth);
		H_o_nbo_backward(vx2, vy2, vx0, vy0, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_lifo.getNextDataPtr();
}

inline void H_o_obo_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		K_e_oon_backward(vx2, vy2, vx0, vy0, mx, my, depth);
		V_e_boo_backward(vx1, vy1, vx2, vy2, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_lifo.getNextDataPtr();
}

inline void V_e_boo_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		K_o_onb_backward(vx1, vy1, vx2, vy2, mx, my, depth);
		H_o_obo_backward(vx2, vy2, vx0, vy0, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_lifo.getNextDataPtr();
}

inline void K_o_boo_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		V_e_obn_backward(vx2, vy2, vx0, vy0, mx, my, depth);
		H_e_oob_backward(vx1, vy1, vx2, vy2, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_lifo.getNextDataPtr();
}

inline void V_e_obn_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		K_o_bno_backward(vx1, vy1, vx2, vy2, mx, my, depth);
		H_o_noo_backward(vx2, vy2, vx0, vy0, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_lifo.getNextDataPtr();
}

inline void K_o_bno_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		V_e_obn_backward(vx2, vy2, vx0, vy0, mx, my, depth);
		H_e_nob_backward(vx1, vy1, vx2, vy2, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_lifo.getNextDataPtr();
}

inline void H_e_oob_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		K_o_ono_backward(vx1, vy1, vx2, vy2, mx, my, depth);
		V_o_boo_backward(vx2, vy2, vx0, vy0, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_lifo.getNextDataPtr();
}

inline void V_o_boo_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		K_e_obn_backward(vx2, vy2, vx0, vy0, mx, my, depth);
		H_e_oob_backward(vx1, vy1, vx2, vy2, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_lifo.getNextDataPtr();
}

inline void K_e_nbn_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		V_o_bnn_backward(vx1, vy1, vx2, vy2, mx, my, depth);
		H_o_nno_backward(vx2, vy2, vx0, vy0, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_lifo.getNextDataPtr();
}

inline void V_o_bnn_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		K_e_nbn_backward(vx2, vy2, vx0, vy0, mx, my, depth);
		H_e_nob_backward(vx1, vy1, vx2, vy2, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_lifo.getNextDataPtr();
}

inline void K_o_nbn_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		V_e_nnn_backward(vx2, vy2, vx0, vy0, mx, my, depth);
		H_e_bon_backward(vx1, vy1, vx2, vy2, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_lifo.getNextDataPtr();
}

inline void H_e_bon_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		K_o_onb_backward(vx1, vy1, vx2, vy2, mx, my, depth);
		V_o_nbo_backward(vx2, vy2, vx0, vy0, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_lifo.getNextDataPtr();
}

inline void V_o_nbo_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		K_e_onn_backward(vx2, vy2, vx0, vy0, mx, my, depth);
		H_e_bon_backward(vx1, vy1, vx2, vy2, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_lifo.getNextDataPtr();
}

inline void K_e_obo_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		V_o_bno_backward(vx1, vy1, vx2, vy2, mx, my, depth);
		H_o_ooo_backward(vx2, vy2, vx0, vy0, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_lifo.getNextDataPtr();
}

inline void K_o_obo_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		V_e_oon_backward(vx2, vy2, vx0, vy0, mx, my, depth);
		H_e_boo_backward(vx1, vy1, vx2, vy2, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_lifo.getNextDataPtr();
}

inline void H_e_boo_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		K_o_onb_backward(vx1, vy1, vx2, vy2, mx, my, depth);
		V_o_obo_backward(vx2, vy2, vx0, vy0, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_lifo.getNextDataPtr();
}

inline void V_o_obo_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		K_e_oon_backward(vx2, vy2, vx0, vy0, mx, my, depth);
		H_e_boo_backward(vx1, vy1, vx2, vy2, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_lifo.getNextDataPtr();
}

inline void K_e_nnb_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		V_o_nnn_backward(vx1, vy1, vx2, vy2, mx, my, depth);
		H_o_bno_backward(vx2, vy2, vx0, vy0, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_lifo.getNextDataPtr();
}

inline void H_o_bno_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		K_e_obn_backward(vx2, vy2, vx0, vy0, mx, my, depth);
		V_e_nob_backward(vx1, vy1, vx2, vy2, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_lifo.getNextDataPtr();
}

inline void V_e_nob_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		K_o_onn_backward(vx1, vy1, vx2, vy2, mx, my, depth);
		H_o_bno_backward(vx2, vy2, vx0, vy0, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_lifo.getNextDataPtr();
}

inline void K_o_nnb_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		V_e_bnn_backward(vx2, vy2, vx0, vy0, mx, my, depth);
		H_e_non_backward(vx1, vy1, vx2, vy2, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_lifo.getNextDataPtr();
}

inline void V_e_bnn_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		K_o_nnb_backward(vx1, vy1, vx2, vy2, mx, my, depth);
		H_o_nbo_backward(vx2, vy2, vx0, vy0, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_lifo.getNextDataPtr();
}

inline void K_e_oob_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		V_o_ono_backward(vx1, vy1, vx2, vy2, mx, my, depth);
		H_o_boo_backward(vx2, vy2, vx0, vy0, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_lifo.getNextDataPtr();
}

inline void H_o_boo_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		K_e_obn_backward(vx2, vy2, vx0, vy0, mx, my, depth);
		V_e_oob_backward(vx1, vy1, vx2, vy2, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_lifo.getNextDataPtr();
}

inline void V_e_oob_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		K_o_ono_backward(vx1, vy1, vx2, vy2, mx, my, depth);
		H_o_boo_backward(vx2, vy2, vx0, vy0, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_lifo.getNextDataPtr();
}

inline void K_o_oob_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		V_e_bon_backward(vx2, vy2, vx0, vy0, mx, my, depth);
		H_e_ooo_backward(vx1, vy1, vx2, vy2, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_lifo.getNextDataPtr();
}

inline void K_o_bbn_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		V_e_nbn_backward(vx2, vy2, vx0, vy0, mx, my, depth);
		H_e_bob_backward(vx1, vy1, vx2, vy2, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_lifo.getNextDataPtr();
}

inline void K_e_bbo_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		V_o_bnb_backward(vx1, vy1, vx2, vy2, mx, my, depth);
		H_o_obo_backward(vx2, vy2, vx0, vy0, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_lifo.getNextDataPtr();
}

inline void K_o_bbo_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		V_e_obn_backward(vx2, vy2, vx0, vy0, mx, my, depth);
		H_e_bob_backward(vx1, vy1, vx2, vy2, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_lifo.getNextDataPtr();
}

inline void K_e_nbb_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		V_o_bnn_backward(vx1, vy1, vx2, vy2, mx, my, depth);
		H_o_bno_backward(vx2, vy2, vx0, vy0, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_lifo.getNextDataPtr();
}

inline void K_o_nbb_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		V_e_bnn_backward(vx2, vy2, vx0, vy0, mx, my, depth);
		H_e_bon_backward(vx1, vy1, vx2, vy2, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_lifo.getNextDataPtr();
}

inline void K_e_obb_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		V_o_bno_backward(vx1, vy1, vx2, vy2, mx, my, depth);
		H_o_boo_backward(vx2, vy2, vx0, vy0, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_lifo.getNextDataPtr();
}

inline void K_o_obb_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		V_e_bon_backward(vx2, vy2, vx0, vy0, mx, my, depth);
		H_e_boo_backward(vx1, vy1, vx2, vy2, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_lifo.getNextDataPtr();
}

inline void K_e_bnb_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		V_o_nnb_backward(vx1, vy1, vx2, vy2, mx, my, depth);
		H_o_bbo_backward(vx2, vy2, vx0, vy0, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_lifo.getNextDataPtr();
}

inline void K_e_bob_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		V_o_onb_backward(vx1, vy1, vx2, vy2, mx, my, depth);
		H_o_bbo_backward(vx2, vy2, vx0, vy0, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_lifo.getNextDataPtr();
}

inline void K_o_bob_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		V_e_bbn_backward(vx2, vy2, vx0, vy0, mx, my, depth);
		H_e_oob_backward(vx1, vy1, vx2, vy2, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_lifo.getNextDataPtr();
}
