
/*
 * Copyright (C) 2011 Technische Universitaet Muenchen
 * This file is part of the Sierpinski project. For conditions of distribution and
 * use, please see the copyright notice in the file 'copyright.txt' at the root
 * directory of this package and the copyright notice at http://www5.in.tum.de/sierpinski
 *
 * This file was automatically generated by the sierpinski code generator
 */


inline void K_e_bbb_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_o_bbn_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		V_o_bob_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	TVertexData vertexDataright = vertex_data_comm_right_edge_stack->pop_returnRef();
	TVertexData vertexDatatop = vertex_data_comm_right_edge_stack->pop_returnRef();
	TVertexData vertexDataleft = vertex_data_comm_left_edge_stack->pop_returnRef();
	cKernelClass.op_cell(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, &vertexDataleft, &vertexDataright, &vertexDatatop);
}

inline void H_o_bbn_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		V_e_bnb_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		K_e_nbo_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	// isMiddleTouchVertex
	TVertexData vertexDataleft = vertex_data_comm_right_edge_stack->getTopElementRef();
	// isMiddleTouchVertex
	TVertexData vertexDatatop = vertex_data_comm_left_edge_stack->getTopElementRef();
	TVertexData vertexDataright = vertex_data_comm_left_edge_stack->pop_returnRef();
	cKernelClass.op_cell(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, &vertexDataleft, &vertexDataright, &vertexDatatop);
}

inline void V_e_bnb_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_o_bbn_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		K_o_nob_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	// isMiddleTouchVertex
	TVertexData vertexDataright = vertex_data_comm_left_edge_stack->getTopElementRef();
	// isMiddleTouchVertex
	TVertexData vertexDatatop = vertex_data_comm_right_edge_stack->getTopElementRef();
	TVertexData vertexDataleft = vertex_data_comm_left_edge_stack->pop_returnRef();
	cKernelClass.op_cell(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, &vertexDataleft, &vertexDataright, &vertexDatatop);
}

inline void K_o_nob_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_e_onn_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		V_e_bno_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	// isMiddleTouchVertex
	TVertexData vertexDataleft = vertex_data_comm_left_edge_stack->getTopElementRef();
	TVertexData vertexDatatop = vertex_data_comm_left_edge_stack->pop_returnRef();
	// isMiddleTouchVertex
	TVertexData vertexDataright = vertex_data_comm_right_edge_stack->getTopElementRef();
	cKernelClass.op_cell(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, &vertexDataleft, &vertexDataright, &vertexDatatop);
}

inline void H_e_onn_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		V_o_non_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		K_o_noo_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	// isMiddleTouchVertex
	TVertexData vertexDataright = vertex_data_comm_left_edge_stack->getTopElementRef();
	TVertexData &vertexDatatop = vertex_data_comm_buffer_input->pop_returnRef();
	vertex_data_comm_right_edge_stack->push(vertexDatatop);
	// isMiddleTouchVertex
	TVertexData vertexDataleft = vertex_data_comm_right_edge_stack->getTopElementRef();
	cKernelClass.op_cell(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, &vertexDataleft, &vertexDataright, &vertexDatatop);
}

inline void V_o_non_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_e_onn_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		K_e_nno_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	TVertexData &vertexDataleft = vertex_data_comm_buffer_input->pop_returnRef();
	vertex_data_comm_right_edge_stack->push(vertexDataleft);
	// isMiddleTouchVertex
	TVertexData vertexDatatop = vertex_data_comm_left_edge_stack->getTopElementRef();
	// isMiddleTouchVertex
	TVertexData vertexDataright = vertex_data_comm_right_edge_stack->getTopElementRef();
	cKernelClass.op_cell(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, &vertexDataleft, &vertexDataright, &vertexDatatop);
}

inline void K_e_nno_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_o_onn_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		V_o_non_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	TVertexData &vertexDataright = vertex_data_comm_buffer_input->pop_returnRef();
	vertex_data_comm_right_edge_stack->push(vertexDataright);
	// isMiddleTouchVertex
	TVertexData vertexDatatop = vertex_data_comm_right_edge_stack->getTopElementRef();
	// isMiddleTouchVertex
	TVertexData vertexDataleft = vertex_data_comm_left_edge_stack->getTopElementRef();
	cKernelClass.op_cell(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, &vertexDataleft, &vertexDataright, &vertexDatatop);
}

inline void H_o_onn_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		V_e_nno_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		K_e_noo_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	// isMiddleTouchVertex
	TVertexData vertexDataleft = vertex_data_comm_right_edge_stack->getTopElementRef();
	TVertexData &vertexDatatop = vertex_data_comm_buffer_input->pop_returnRef();
	vertex_data_comm_left_edge_stack->push(vertexDatatop);
	// isMiddleTouchVertex
	TVertexData vertexDataright = vertex_data_comm_left_edge_stack->getTopElementRef();
	cKernelClass.op_cell(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, &vertexDataleft, &vertexDataright, &vertexDatatop);
}

inline void V_e_nno_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_o_onn_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		K_o_non_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	TVertexData &vertexDataright = vertex_data_comm_buffer_input->pop_returnRef();
	vertex_data_comm_left_edge_stack->push(vertexDataright);
	// isMiddleTouchVertex
	TVertexData vertexDatatop = vertex_data_comm_right_edge_stack->getTopElementRef();
	// isMiddleTouchVertex
	TVertexData vertexDataleft = vertex_data_comm_left_edge_stack->getTopElementRef();
	cKernelClass.op_cell(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, &vertexDataleft, &vertexDataright, &vertexDatatop);
}

inline void K_o_non_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_e_onn_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		V_e_nno_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	TVertexData &vertexDataleft = vertex_data_comm_buffer_input->pop_returnRef();
	vertex_data_comm_left_edge_stack->push(vertexDataleft);
	// isMiddleTouchVertex
	TVertexData vertexDatatop = vertex_data_comm_left_edge_stack->getTopElementRef();
	// isMiddleTouchVertex
	TVertexData vertexDataright = vertex_data_comm_right_edge_stack->getTopElementRef();
	cKernelClass.op_cell(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, &vertexDataleft, &vertexDataright, &vertexDatatop);
}

inline void K_e_noo_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_o_onn_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		V_o_oon_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	// isMiddleTouchVertex
	TVertexData vertexDataright = vertex_data_comm_right_edge_stack->getTopElementRef();
	TVertexData vertexDatatop = vertex_data_comm_right_edge_stack->pop_returnRef();
	// isMiddleTouchVertex
	TVertexData vertexDataleft = vertex_data_comm_left_edge_stack->getTopElementRef();
	cKernelClass.op_cell(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, &vertexDataleft, &vertexDataright, &vertexDatatop);
}

inline void V_o_oon_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_e_ono_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		K_e_noo_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	// isMiddleTouchVertex
	TVertexData vertexDataleft = vertex_data_comm_right_edge_stack->getTopElementRef();
	// isMiddleTouchVertex
	TVertexData vertexDatatop = vertex_data_comm_left_edge_stack->getTopElementRef();
	TVertexData vertexDataright = vertex_data_comm_right_edge_stack->pop_returnRef();
	cKernelClass.op_cell(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, &vertexDataleft, &vertexDataright, &vertexDatatop);
}

inline void H_e_ono_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		V_o_oon_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		K_o_noo_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	// isMiddleTouchVertex
	TVertexData vertexDataright = vertex_data_comm_left_edge_stack->getTopElementRef();
	// isMiddleTouchVertex
	TVertexData vertexDatatop = vertex_data_comm_right_edge_stack->getTopElementRef();
	TVertexData vertexDataleft = vertex_data_comm_right_edge_stack->pop_returnRef();
	cKernelClass.op_cell(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, &vertexDataleft, &vertexDataright, &vertexDatatop);
}

inline void K_o_noo_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_e_onn_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		V_e_ono_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	// isMiddleTouchVertex
	TVertexData vertexDataleft = vertex_data_comm_left_edge_stack->getTopElementRef();
	TVertexData vertexDatatop = vertex_data_comm_left_edge_stack->pop_returnRef();
	// isMiddleTouchVertex
	TVertexData vertexDataright = vertex_data_comm_right_edge_stack->getTopElementRef();
	cKernelClass.op_cell(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, &vertexDataleft, &vertexDataright, &vertexDatatop);
}

inline void V_e_ono_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_o_oon_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		K_o_noo_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	// isMiddleTouchVertex
	TVertexData vertexDataright = vertex_data_comm_left_edge_stack->getTopElementRef();
	// isMiddleTouchVertex
	TVertexData vertexDatatop = vertex_data_comm_right_edge_stack->getTopElementRef();
	TVertexData vertexDataleft = vertex_data_comm_left_edge_stack->pop_returnRef();
	cKernelClass.op_cell(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, &vertexDataleft, &vertexDataright, &vertexDatatop);
}

inline void H_o_oon_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		V_e_ono_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		K_e_noo_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	// isMiddleTouchVertex
	TVertexData vertexDataleft = vertex_data_comm_right_edge_stack->getTopElementRef();
	// isMiddleTouchVertex
	TVertexData vertexDatatop = vertex_data_comm_left_edge_stack->getTopElementRef();
	TVertexData vertexDataright = vertex_data_comm_left_edge_stack->pop_returnRef();
	cKernelClass.op_cell(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, &vertexDataleft, &vertexDataright, &vertexDatatop);
}

inline void V_e_bno_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_o_obn_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		K_o_nob_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	// isMiddleTouchVertex
	TVertexData vertexDataright = vertex_data_comm_left_edge_stack->getTopElementRef();
	// isMiddleTouchVertex
	TVertexData vertexDatatop = vertex_data_comm_right_edge_stack->getTopElementRef();
	TVertexData vertexDataleft = vertex_data_comm_left_edge_stack->pop_returnRef();
	cKernelClass.op_cell(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, &vertexDataleft, &vertexDataright, &vertexDatatop);
}

inline void H_o_obn_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		V_e_bno_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		K_e_noo_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	// isMiddleTouchVertex
	TVertexData vertexDataleft = vertex_data_comm_right_edge_stack->getTopElementRef();
	// isMiddleTouchVertex
	TVertexData vertexDatatop = vertex_data_comm_left_edge_stack->getTopElementRef();
	TVertexData vertexDataright = vertex_data_comm_left_edge_stack->pop_returnRef();
	cKernelClass.op_cell(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, &vertexDataleft, &vertexDataright, &vertexDatatop);
}

inline void K_e_nbo_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_o_onn_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		V_o_bon_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	// isMiddleTouchVertex
	TVertexData vertexDataright = vertex_data_comm_right_edge_stack->getTopElementRef();
	TVertexData vertexDatatop = vertex_data_comm_right_edge_stack->pop_returnRef();
	// isMiddleTouchVertex
	TVertexData vertexDataleft = vertex_data_comm_left_edge_stack->getTopElementRef();
	cKernelClass.op_cell(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, &vertexDataleft, &vertexDataright, &vertexDatatop);
}

inline void V_o_bon_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_e_onb_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		K_e_nbo_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	// isMiddleTouchVertex
	TVertexData vertexDataleft = vertex_data_comm_right_edge_stack->getTopElementRef();
	// isMiddleTouchVertex
	TVertexData vertexDatatop = vertex_data_comm_left_edge_stack->getTopElementRef();
	TVertexData vertexDataright = vertex_data_comm_right_edge_stack->pop_returnRef();
	cKernelClass.op_cell(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, &vertexDataleft, &vertexDataright, &vertexDatatop);
}

inline void H_e_onb_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		V_o_bon_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		K_o_noo_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	// isMiddleTouchVertex
	TVertexData vertexDataright = vertex_data_comm_left_edge_stack->getTopElementRef();
	// isMiddleTouchVertex
	TVertexData vertexDatatop = vertex_data_comm_right_edge_stack->getTopElementRef();
	TVertexData vertexDataleft = vertex_data_comm_right_edge_stack->pop_returnRef();
	cKernelClass.op_cell(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, &vertexDataleft, &vertexDataright, &vertexDatatop);
}

inline void V_o_bob_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_e_onb_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		K_e_bbo_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	TVertexData vertexDataleft = vertex_data_comm_right_edge_stack->pop_returnRef();
	TVertexData vertexDatatop = vertex_data_comm_left_edge_stack->pop_returnRef();
	TVertexData vertexDataright = vertex_data_comm_right_edge_stack->pop_returnRef();
	cKernelClass.op_cell(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, &vertexDataleft, &vertexDataright, &vertexDatatop);
}

inline void K_e_bbo_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_o_obn_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		V_o_bob_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	TVertexData vertexDataright = vertex_data_comm_right_edge_stack->pop_returnRef();
	TVertexData vertexDatatop = vertex_data_comm_right_edge_stack->pop_returnRef();
	TVertexData vertexDataleft = vertex_data_comm_left_edge_stack->pop_returnRef();
	cKernelClass.op_cell(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, &vertexDataleft, &vertexDataright, &vertexDatatop);
}

inline void K_o_bbb_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_e_bnb_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		V_e_bbo_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	TVertexData vertexDataleft = vertex_data_comm_left_edge_stack->pop_returnRef();
	TVertexData vertexDatatop = vertex_data_comm_left_edge_stack->pop_returnRef();
	TVertexData vertexDataright = vertex_data_comm_right_edge_stack->pop_returnRef();
	cKernelClass.op_cell(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, &vertexDataleft, &vertexDataright, &vertexDatatop);
}

inline void H_e_bnb_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		V_o_bbn_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		K_o_nob_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	// isMiddleTouchVertex
	TVertexData vertexDataright = vertex_data_comm_left_edge_stack->getTopElementRef();
	// isMiddleTouchVertex
	TVertexData vertexDatatop = vertex_data_comm_right_edge_stack->getTopElementRef();
	TVertexData vertexDataleft = vertex_data_comm_right_edge_stack->pop_returnRef();
	cKernelClass.op_cell(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, &vertexDataleft, &vertexDataright, &vertexDatatop);
}

inline void V_o_bbn_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_e_bnb_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		K_e_nbo_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	// isMiddleTouchVertex
	TVertexData vertexDataleft = vertex_data_comm_right_edge_stack->getTopElementRef();
	// isMiddleTouchVertex
	TVertexData vertexDatatop = vertex_data_comm_left_edge_stack->getTopElementRef();
	TVertexData vertexDataright = vertex_data_comm_right_edge_stack->pop_returnRef();
	cKernelClass.op_cell(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, &vertexDataleft, &vertexDataright, &vertexDatatop);
}

inline void V_e_bbo_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_o_obn_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		K_o_bob_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	TVertexData vertexDataright = vertex_data_comm_left_edge_stack->pop_returnRef();
	TVertexData vertexDatatop = vertex_data_comm_right_edge_stack->pop_returnRef();
	TVertexData vertexDataleft = vertex_data_comm_left_edge_stack->pop_returnRef();
	cKernelClass.op_cell(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, &vertexDataleft, &vertexDataright, &vertexDatatop);
}

inline void K_o_bob_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_e_onb_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		V_e_bbo_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	TVertexData vertexDataleft = vertex_data_comm_left_edge_stack->pop_returnRef();
	TVertexData vertexDatatop = vertex_data_comm_left_edge_stack->pop_returnRef();
	TVertexData vertexDataright = vertex_data_comm_right_edge_stack->pop_returnRef();
	cKernelClass.op_cell(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, &vertexDataleft, &vertexDataright, &vertexDatatop);
}

inline void K_e_nnn_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_o_nnn_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		V_o_non_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	TVertexData &vertexDataright = vertex_data_comm_buffer_input->pop_returnRef();
	vertex_data_comm_right_edge_stack->push(vertexDataright);
	TVertexData &vertexDatatop = vertex_data_comm_buffer_input->pop_returnRef();
	vertex_data_comm_right_edge_stack->push(vertexDatatop);
	TVertexData &vertexDataleft = vertex_data_comm_buffer_input->pop_returnRef();
	vertex_data_comm_left_edge_stack->push(vertexDataleft);
	cKernelClass.op_cell(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, &vertexDataleft, &vertexDataright, &vertexDatatop);
}

inline void H_o_nnn_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		V_e_nnn_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		K_e_nno_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	TVertexData &vertexDataleft = vertex_data_comm_buffer_input->pop_returnRef();
	vertex_data_comm_right_edge_stack->push(vertexDataleft);
	TVertexData &vertexDatatop = vertex_data_comm_buffer_input->pop_returnRef();
	vertex_data_comm_left_edge_stack->push(vertexDatatop);
	TVertexData &vertexDataright = vertex_data_comm_buffer_input->pop_returnRef();
	vertex_data_comm_left_edge_stack->push(vertexDataright);
	cKernelClass.op_cell(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, &vertexDataleft, &vertexDataright, &vertexDatatop);
}

inline void V_e_nnn_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_o_nnn_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		K_o_non_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	TVertexData &vertexDataright = vertex_data_comm_buffer_input->pop_returnRef();
	vertex_data_comm_left_edge_stack->push(vertexDataright);
	TVertexData &vertexDatatop = vertex_data_comm_buffer_input->pop_returnRef();
	vertex_data_comm_right_edge_stack->push(vertexDatatop);
	TVertexData &vertexDataleft = vertex_data_comm_buffer_input->pop_returnRef();
	vertex_data_comm_left_edge_stack->push(vertexDataleft);
	cKernelClass.op_cell(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, &vertexDataleft, &vertexDataright, &vertexDatatop);
}

inline void K_o_nnn_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_e_nnn_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		V_e_nno_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	TVertexData &vertexDataleft = vertex_data_comm_buffer_input->pop_returnRef();
	vertex_data_comm_left_edge_stack->push(vertexDataleft);
	TVertexData &vertexDatatop = vertex_data_comm_buffer_input->pop_returnRef();
	vertex_data_comm_left_edge_stack->push(vertexDatatop);
	TVertexData &vertexDataright = vertex_data_comm_buffer_input->pop_returnRef();
	vertex_data_comm_right_edge_stack->push(vertexDataright);
	cKernelClass.op_cell(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, &vertexDataleft, &vertexDataright, &vertexDatatop);
}

inline void H_e_nnn_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		V_o_nnn_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		K_o_non_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	TVertexData &vertexDataright = vertex_data_comm_buffer_input->pop_returnRef();
	vertex_data_comm_left_edge_stack->push(vertexDataright);
	TVertexData &vertexDatatop = vertex_data_comm_buffer_input->pop_returnRef();
	vertex_data_comm_right_edge_stack->push(vertexDatatop);
	TVertexData &vertexDataleft = vertex_data_comm_buffer_input->pop_returnRef();
	vertex_data_comm_right_edge_stack->push(vertexDataleft);
	cKernelClass.op_cell(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, &vertexDataleft, &vertexDataright, &vertexDatatop);
}

inline void V_o_nnn_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_e_nnn_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		K_e_nno_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	TVertexData &vertexDataleft = vertex_data_comm_buffer_input->pop_returnRef();
	vertex_data_comm_right_edge_stack->push(vertexDataleft);
	TVertexData &vertexDatatop = vertex_data_comm_buffer_input->pop_returnRef();
	vertex_data_comm_left_edge_stack->push(vertexDatatop);
	TVertexData &vertexDataright = vertex_data_comm_buffer_input->pop_returnRef();
	vertex_data_comm_right_edge_stack->push(vertexDataright);
	cKernelClass.op_cell(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, &vertexDataleft, &vertexDataright, &vertexDatatop);
}

inline void K_e_ooo_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_o_oon_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		V_o_ooo_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	TVertexData vertexDataright = vertex_data_comm_right_edge_stack->pop_returnRef();
	TVertexData vertexDatatop = vertex_data_comm_right_edge_stack->pop_returnRef();
	TVertexData vertexDataleft = vertex_data_comm_left_edge_stack->pop_returnRef();
	cKernelClass.op_cell(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, &vertexDataleft, &vertexDataright, &vertexDatatop);
}

inline void V_o_ooo_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_e_ono_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		K_e_ooo_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	TVertexData vertexDataleft = vertex_data_comm_right_edge_stack->pop_returnRef();
	TVertexData vertexDatatop = vertex_data_comm_left_edge_stack->pop_returnRef();
	TVertexData vertexDataright = vertex_data_comm_right_edge_stack->pop_returnRef();
	cKernelClass.op_cell(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, &vertexDataleft, &vertexDataright, &vertexDatatop);
}

inline void K_o_ooo_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_e_ono_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		V_e_ooo_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	TVertexData vertexDataleft = vertex_data_comm_left_edge_stack->pop_returnRef();
	TVertexData vertexDatatop = vertex_data_comm_left_edge_stack->pop_returnRef();
	TVertexData vertexDataright = vertex_data_comm_right_edge_stack->pop_returnRef();
	cKernelClass.op_cell(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, &vertexDataleft, &vertexDataright, &vertexDatatop);
}

inline void V_e_ooo_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_o_oon_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		K_o_ooo_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	TVertexData vertexDataright = vertex_data_comm_left_edge_stack->pop_returnRef();
	TVertexData vertexDatatop = vertex_data_comm_right_edge_stack->pop_returnRef();
	TVertexData vertexDataleft = vertex_data_comm_left_edge_stack->pop_returnRef();
	cKernelClass.op_cell(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, &vertexDataleft, &vertexDataright, &vertexDatatop);
}

inline void K_e_bnn_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_o_nbn_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		V_o_nob_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	// isMiddleTouchVertex
	TVertexData vertexDataright = vertex_data_comm_right_edge_stack->getTopElementRef();
	TVertexData &vertexDatatop = vertex_data_comm_buffer_input->pop_returnRef();
	vertex_data_comm_right_edge_stack->push(vertexDatatop);
	// isMiddleTouchVertex
	TVertexData vertexDataleft = vertex_data_comm_left_edge_stack->getTopElementRef();
	cKernelClass.op_cell(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, &vertexDataleft, &vertexDataright, &vertexDatatop);
}

inline void H_o_nbn_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		V_e_bnn_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		K_e_nno_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	TVertexData &vertexDataleft = vertex_data_comm_buffer_input->pop_returnRef();
	vertex_data_comm_right_edge_stack->push(vertexDataleft);
	// isMiddleTouchVertex
	TVertexData vertexDatatop = vertex_data_comm_left_edge_stack->getTopElementRef();
	// isMiddleTouchVertex
	TVertexData vertexDataright = vertex_data_comm_left_edge_stack->getTopElementRef();
	cKernelClass.op_cell(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, &vertexDataleft, &vertexDataright, &vertexDatatop);
}

inline void V_e_bnn_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_o_nbn_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		K_o_nob_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	// isMiddleTouchVertex
	TVertexData vertexDataright = vertex_data_comm_left_edge_stack->getTopElementRef();
	TVertexData &vertexDatatop = vertex_data_comm_buffer_input->pop_returnRef();
	vertex_data_comm_right_edge_stack->push(vertexDatatop);
	// isMiddleTouchVertex
	TVertexData vertexDataleft = vertex_data_comm_left_edge_stack->getTopElementRef();
	cKernelClass.op_cell(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, &vertexDataleft, &vertexDataright, &vertexDatatop);
}

inline void V_o_nob_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_e_onn_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		K_e_bno_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	// isMiddleTouchVertex
	TVertexData vertexDataleft = vertex_data_comm_right_edge_stack->getTopElementRef();
	TVertexData vertexDatatop = vertex_data_comm_left_edge_stack->pop_returnRef();
	// isMiddleTouchVertex
	TVertexData vertexDataright = vertex_data_comm_right_edge_stack->getTopElementRef();
	cKernelClass.op_cell(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, &vertexDataleft, &vertexDataright, &vertexDatatop);
}

inline void K_e_bno_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_o_obn_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		V_o_nob_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	// isMiddleTouchVertex
	TVertexData vertexDataright = vertex_data_comm_right_edge_stack->getTopElementRef();
	// isMiddleTouchVertex
	TVertexData vertexDatatop = vertex_data_comm_right_edge_stack->getTopElementRef();
	TVertexData vertexDataleft = vertex_data_comm_left_edge_stack->pop_returnRef();
	cKernelClass.op_cell(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, &vertexDataleft, &vertexDataright, &vertexDatatop);
}

inline void K_o_bnn_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_e_nnb_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		V_e_nbo_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	// isMiddleTouchVertex
	TVertexData vertexDataleft = vertex_data_comm_left_edge_stack->getTopElementRef();
	TVertexData &vertexDatatop = vertex_data_comm_buffer_input->pop_returnRef();
	vertex_data_comm_left_edge_stack->push(vertexDatatop);
	// isMiddleTouchVertex
	TVertexData vertexDataright = vertex_data_comm_right_edge_stack->getTopElementRef();
	cKernelClass.op_cell(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, &vertexDataleft, &vertexDataright, &vertexDatatop);
}

inline void H_e_nnb_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		V_o_bnn_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		K_o_non_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	TVertexData &vertexDataright = vertex_data_comm_buffer_input->pop_returnRef();
	vertex_data_comm_left_edge_stack->push(vertexDataright);
	// isMiddleTouchVertex
	TVertexData vertexDatatop = vertex_data_comm_right_edge_stack->getTopElementRef();
	// isMiddleTouchVertex
	TVertexData vertexDataleft = vertex_data_comm_right_edge_stack->getTopElementRef();
	cKernelClass.op_cell(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, &vertexDataleft, &vertexDataright, &vertexDatatop);
}

inline void V_o_bnn_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_e_nnb_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		K_e_nbo_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	// isMiddleTouchVertex
	TVertexData vertexDataleft = vertex_data_comm_right_edge_stack->getTopElementRef();
	TVertexData &vertexDatatop = vertex_data_comm_buffer_input->pop_returnRef();
	vertex_data_comm_left_edge_stack->push(vertexDatatop);
	// isMiddleTouchVertex
	TVertexData vertexDataright = vertex_data_comm_right_edge_stack->getTopElementRef();
	cKernelClass.op_cell(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, &vertexDataleft, &vertexDataright, &vertexDatatop);
}

inline void V_e_nbo_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_o_onn_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		K_o_bon_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	// isMiddleTouchVertex
	TVertexData vertexDataright = vertex_data_comm_left_edge_stack->getTopElementRef();
	TVertexData vertexDatatop = vertex_data_comm_right_edge_stack->pop_returnRef();
	// isMiddleTouchVertex
	TVertexData vertexDataleft = vertex_data_comm_left_edge_stack->getTopElementRef();
	cKernelClass.op_cell(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, &vertexDataleft, &vertexDataright, &vertexDatatop);
}

inline void K_o_bon_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_e_onb_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		V_e_nbo_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	// isMiddleTouchVertex
	TVertexData vertexDataleft = vertex_data_comm_left_edge_stack->getTopElementRef();
	// isMiddleTouchVertex
	TVertexData vertexDatatop = vertex_data_comm_left_edge_stack->getTopElementRef();
	TVertexData vertexDataright = vertex_data_comm_right_edge_stack->pop_returnRef();
	cKernelClass.op_cell(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, &vertexDataleft, &vertexDataright, &vertexDatatop);
}

inline void K_e_boo_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_o_obn_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		V_o_oob_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	TVertexData vertexDataright = vertex_data_comm_right_edge_stack->pop_returnRef();
	TVertexData vertexDatatop = vertex_data_comm_right_edge_stack->pop_returnRef();
	TVertexData vertexDataleft = vertex_data_comm_left_edge_stack->pop_returnRef();
	cKernelClass.op_cell(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, &vertexDataleft, &vertexDataright, &vertexDatatop);
}

inline void V_o_oob_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_e_ono_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		K_e_boo_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	TVertexData vertexDataleft = vertex_data_comm_right_edge_stack->pop_returnRef();
	TVertexData vertexDatatop = vertex_data_comm_left_edge_stack->pop_returnRef();
	TVertexData vertexDataright = vertex_data_comm_right_edge_stack->pop_returnRef();
	cKernelClass.op_cell(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, &vertexDataleft, &vertexDataright, &vertexDatatop);
}

inline void K_o_boo_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_e_onb_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		V_e_obo_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	TVertexData vertexDataleft = vertex_data_comm_left_edge_stack->pop_returnRef();
	TVertexData vertexDatatop = vertex_data_comm_left_edge_stack->pop_returnRef();
	TVertexData vertexDataright = vertex_data_comm_right_edge_stack->pop_returnRef();
	cKernelClass.op_cell(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, &vertexDataleft, &vertexDataright, &vertexDatatop);
}

inline void V_e_obo_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_o_oon_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		K_o_boo_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	TVertexData vertexDataright = vertex_data_comm_left_edge_stack->pop_returnRef();
	TVertexData vertexDatatop = vertex_data_comm_right_edge_stack->pop_returnRef();
	TVertexData vertexDataleft = vertex_data_comm_left_edge_stack->pop_returnRef();
	cKernelClass.op_cell(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, &vertexDataleft, &vertexDataright, &vertexDatatop);
}

inline void K_e_nbn_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_o_nnn_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		V_o_bon_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	// isMiddleTouchVertex
	TVertexData vertexDataright = vertex_data_comm_right_edge_stack->getTopElementRef();
	// isMiddleTouchVertex
	TVertexData vertexDatatop = vertex_data_comm_right_edge_stack->getTopElementRef();
	TVertexData &vertexDataleft = vertex_data_comm_buffer_input->pop_returnRef();
	vertex_data_comm_left_edge_stack->push(vertexDataleft);
	cKernelClass.op_cell(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, &vertexDataleft, &vertexDataright, &vertexDatatop);
}

inline void K_o_nbn_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_e_bnn_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		V_e_nno_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	TVertexData &vertexDataleft = vertex_data_comm_buffer_input->pop_returnRef();
	vertex_data_comm_left_edge_stack->push(vertexDataleft);
	// isMiddleTouchVertex
	TVertexData vertexDatatop = vertex_data_comm_left_edge_stack->getTopElementRef();
	// isMiddleTouchVertex
	TVertexData vertexDataright = vertex_data_comm_right_edge_stack->getTopElementRef();
	cKernelClass.op_cell(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, &vertexDataleft, &vertexDataright, &vertexDatatop);
}

inline void H_e_bnn_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		V_o_nbn_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		K_o_nob_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	// isMiddleTouchVertex
	TVertexData vertexDataright = vertex_data_comm_left_edge_stack->getTopElementRef();
	TVertexData &vertexDatatop = vertex_data_comm_buffer_input->pop_returnRef();
	vertex_data_comm_right_edge_stack->push(vertexDatatop);
	// isMiddleTouchVertex
	TVertexData vertexDataleft = vertex_data_comm_right_edge_stack->getTopElementRef();
	cKernelClass.op_cell(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, &vertexDataleft, &vertexDataright, &vertexDatatop);
}

inline void V_o_nbn_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_e_bnn_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		K_e_nno_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	TVertexData &vertexDataleft = vertex_data_comm_buffer_input->pop_returnRef();
	vertex_data_comm_right_edge_stack->push(vertexDataleft);
	// isMiddleTouchVertex
	TVertexData vertexDatatop = vertex_data_comm_left_edge_stack->getTopElementRef();
	// isMiddleTouchVertex
	TVertexData vertexDataright = vertex_data_comm_right_edge_stack->getTopElementRef();
	cKernelClass.op_cell(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, &vertexDataleft, &vertexDataright, &vertexDatatop);
}

inline void K_e_obo_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_o_oon_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		V_o_boo_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	TVertexData vertexDataright = vertex_data_comm_right_edge_stack->pop_returnRef();
	TVertexData vertexDatatop = vertex_data_comm_right_edge_stack->pop_returnRef();
	TVertexData vertexDataleft = vertex_data_comm_left_edge_stack->pop_returnRef();
	cKernelClass.op_cell(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, &vertexDataleft, &vertexDataright, &vertexDatatop);
}

inline void V_o_boo_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_e_onb_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		K_e_obo_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	TVertexData vertexDataleft = vertex_data_comm_right_edge_stack->pop_returnRef();
	TVertexData vertexDatatop = vertex_data_comm_left_edge_stack->pop_returnRef();
	TVertexData vertexDataright = vertex_data_comm_right_edge_stack->pop_returnRef();
	cKernelClass.op_cell(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, &vertexDataleft, &vertexDataright, &vertexDatatop);
}

inline void K_o_obo_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_e_bno_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		V_e_ooo_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	TVertexData vertexDataleft = vertex_data_comm_left_edge_stack->pop_returnRef();
	TVertexData vertexDatatop = vertex_data_comm_left_edge_stack->pop_returnRef();
	TVertexData vertexDataright = vertex_data_comm_right_edge_stack->pop_returnRef();
	cKernelClass.op_cell(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, &vertexDataleft, &vertexDataright, &vertexDatatop);
}

inline void H_e_bno_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		V_o_obn_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		K_o_nob_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	// isMiddleTouchVertex
	TVertexData vertexDataright = vertex_data_comm_left_edge_stack->getTopElementRef();
	// isMiddleTouchVertex
	TVertexData vertexDatatop = vertex_data_comm_right_edge_stack->getTopElementRef();
	TVertexData vertexDataleft = vertex_data_comm_right_edge_stack->pop_returnRef();
	cKernelClass.op_cell(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, &vertexDataleft, &vertexDataright, &vertexDatatop);
}

inline void V_o_obn_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_e_bno_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		K_e_noo_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	// isMiddleTouchVertex
	TVertexData vertexDataleft = vertex_data_comm_right_edge_stack->getTopElementRef();
	// isMiddleTouchVertex
	TVertexData vertexDatatop = vertex_data_comm_left_edge_stack->getTopElementRef();
	TVertexData vertexDataright = vertex_data_comm_right_edge_stack->pop_returnRef();
	cKernelClass.op_cell(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, &vertexDataleft, &vertexDataright, &vertexDatatop);
}

inline void K_e_nnb_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_o_bnn_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		V_o_non_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	TVertexData &vertexDataright = vertex_data_comm_buffer_input->pop_returnRef();
	vertex_data_comm_right_edge_stack->push(vertexDataright);
	// isMiddleTouchVertex
	TVertexData vertexDatatop = vertex_data_comm_right_edge_stack->getTopElementRef();
	// isMiddleTouchVertex
	TVertexData vertexDataleft = vertex_data_comm_left_edge_stack->getTopElementRef();
	cKernelClass.op_cell(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, &vertexDataleft, &vertexDataright, &vertexDatatop);
}

inline void H_o_bnn_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		V_e_nnb_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		K_e_nbo_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	// isMiddleTouchVertex
	TVertexData vertexDataleft = vertex_data_comm_right_edge_stack->getTopElementRef();
	TVertexData &vertexDatatop = vertex_data_comm_buffer_input->pop_returnRef();
	vertex_data_comm_left_edge_stack->push(vertexDatatop);
	// isMiddleTouchVertex
	TVertexData vertexDataright = vertex_data_comm_left_edge_stack->getTopElementRef();
	cKernelClass.op_cell(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, &vertexDataleft, &vertexDataright, &vertexDatatop);
}

inline void V_e_nnb_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_o_bnn_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		K_o_non_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	TVertexData &vertexDataright = vertex_data_comm_buffer_input->pop_returnRef();
	vertex_data_comm_left_edge_stack->push(vertexDataright);
	// isMiddleTouchVertex
	TVertexData vertexDatatop = vertex_data_comm_right_edge_stack->getTopElementRef();
	// isMiddleTouchVertex
	TVertexData vertexDataleft = vertex_data_comm_left_edge_stack->getTopElementRef();
	cKernelClass.op_cell(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, &vertexDataleft, &vertexDataright, &vertexDatatop);
}

inline void K_o_nnb_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_e_nnn_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		V_e_bno_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	// isMiddleTouchVertex
	TVertexData vertexDataleft = vertex_data_comm_left_edge_stack->getTopElementRef();
	// isMiddleTouchVertex
	TVertexData vertexDatatop = vertex_data_comm_left_edge_stack->getTopElementRef();
	TVertexData &vertexDataright = vertex_data_comm_buffer_input->pop_returnRef();
	vertex_data_comm_right_edge_stack->push(vertexDataright);
	cKernelClass.op_cell(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, &vertexDataleft, &vertexDataright, &vertexDatatop);
}

inline void K_e_oob_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_o_bon_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		V_o_ooo_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	TVertexData vertexDataright = vertex_data_comm_right_edge_stack->pop_returnRef();
	TVertexData vertexDatatop = vertex_data_comm_right_edge_stack->pop_returnRef();
	TVertexData vertexDataleft = vertex_data_comm_left_edge_stack->pop_returnRef();
	cKernelClass.op_cell(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, &vertexDataleft, &vertexDataright, &vertexDatatop);
}

inline void H_o_bon_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		V_e_onb_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		K_e_nbo_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	// isMiddleTouchVertex
	TVertexData vertexDataleft = vertex_data_comm_right_edge_stack->getTopElementRef();
	// isMiddleTouchVertex
	TVertexData vertexDatatop = vertex_data_comm_left_edge_stack->getTopElementRef();
	TVertexData vertexDataright = vertex_data_comm_left_edge_stack->pop_returnRef();
	cKernelClass.op_cell(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, &vertexDataleft, &vertexDataright, &vertexDatatop);
}

inline void V_e_onb_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_o_bon_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		K_o_noo_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	// isMiddleTouchVertex
	TVertexData vertexDataright = vertex_data_comm_left_edge_stack->getTopElementRef();
	// isMiddleTouchVertex
	TVertexData vertexDatatop = vertex_data_comm_right_edge_stack->getTopElementRef();
	TVertexData vertexDataleft = vertex_data_comm_left_edge_stack->pop_returnRef();
	cKernelClass.op_cell(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, &vertexDataleft, &vertexDataright, &vertexDatatop);
}

inline void K_o_oob_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_e_ono_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		V_e_boo_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	TVertexData vertexDataleft = vertex_data_comm_left_edge_stack->pop_returnRef();
	TVertexData vertexDatatop = vertex_data_comm_left_edge_stack->pop_returnRef();
	TVertexData vertexDataright = vertex_data_comm_right_edge_stack->pop_returnRef();
	cKernelClass.op_cell(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, &vertexDataleft, &vertexDataright, &vertexDatatop);
}

inline void V_e_boo_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_o_obn_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		K_o_oob_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	TVertexData vertexDataright = vertex_data_comm_left_edge_stack->pop_returnRef();
	TVertexData vertexDatatop = vertex_data_comm_right_edge_stack->pop_returnRef();
	TVertexData vertexDataleft = vertex_data_comm_left_edge_stack->pop_returnRef();
	cKernelClass.op_cell(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, &vertexDataleft, &vertexDataright, &vertexDatatop);
}

inline void K_e_bbn_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_o_nbn_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		V_o_bob_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	TVertexData vertexDataright = vertex_data_comm_right_edge_stack->pop_returnRef();
	// isMiddleTouchVertex
	TVertexData vertexDatatop = vertex_data_comm_right_edge_stack->getTopElementRef();
	// isMiddleTouchVertex
	TVertexData vertexDataleft = vertex_data_comm_left_edge_stack->getTopElementRef();
	cKernelClass.op_cell(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, &vertexDataleft, &vertexDataright, &vertexDatatop);
}

inline void K_o_bbn_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_e_bnb_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		V_e_nbo_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	// isMiddleTouchVertex
	TVertexData vertexDataleft = vertex_data_comm_left_edge_stack->getTopElementRef();
	// isMiddleTouchVertex
	TVertexData vertexDatatop = vertex_data_comm_left_edge_stack->getTopElementRef();
	TVertexData vertexDataright = vertex_data_comm_right_edge_stack->pop_returnRef();
	cKernelClass.op_cell(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, &vertexDataleft, &vertexDataright, &vertexDatatop);
}

inline void K_o_bbo_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_e_bnb_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		V_e_obo_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	TVertexData vertexDataleft = vertex_data_comm_left_edge_stack->pop_returnRef();
	TVertexData vertexDatatop = vertex_data_comm_left_edge_stack->pop_returnRef();
	TVertexData vertexDataright = vertex_data_comm_right_edge_stack->pop_returnRef();
	cKernelClass.op_cell(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, &vertexDataleft, &vertexDataright, &vertexDatatop);
}

inline void K_e_nbb_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_o_bnn_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		V_o_bon_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	// isMiddleTouchVertex
	TVertexData vertexDataright = vertex_data_comm_right_edge_stack->getTopElementRef();
	TVertexData vertexDatatop = vertex_data_comm_right_edge_stack->pop_returnRef();
	// isMiddleTouchVertex
	TVertexData vertexDataleft = vertex_data_comm_left_edge_stack->getTopElementRef();
	cKernelClass.op_cell(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, &vertexDataleft, &vertexDataright, &vertexDatatop);
}

inline void K_o_nbb_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_e_bnn_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		V_e_bno_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	// isMiddleTouchVertex
	TVertexData vertexDataleft = vertex_data_comm_left_edge_stack->getTopElementRef();
	TVertexData vertexDatatop = vertex_data_comm_left_edge_stack->pop_returnRef();
	// isMiddleTouchVertex
	TVertexData vertexDataright = vertex_data_comm_right_edge_stack->getTopElementRef();
	cKernelClass.op_cell(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, &vertexDataleft, &vertexDataright, &vertexDatatop);
}

inline void K_e_obb_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_o_bon_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		V_o_boo_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	TVertexData vertexDataright = vertex_data_comm_right_edge_stack->pop_returnRef();
	TVertexData vertexDatatop = vertex_data_comm_right_edge_stack->pop_returnRef();
	TVertexData vertexDataleft = vertex_data_comm_left_edge_stack->pop_returnRef();
	cKernelClass.op_cell(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, &vertexDataleft, &vertexDataright, &vertexDatatop);
}

inline void K_o_obb_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_e_bno_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		V_e_boo_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	TVertexData vertexDataleft = vertex_data_comm_left_edge_stack->pop_returnRef();
	TVertexData vertexDatatop = vertex_data_comm_left_edge_stack->pop_returnRef();
	TVertexData vertexDataright = vertex_data_comm_right_edge_stack->pop_returnRef();
	cKernelClass.op_cell(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, &vertexDataleft, &vertexDataright, &vertexDatatop);
}

inline void K_e_bnb_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_o_bbn_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		V_o_nob_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	// isMiddleTouchVertex
	TVertexData vertexDataright = vertex_data_comm_right_edge_stack->getTopElementRef();
	// isMiddleTouchVertex
	TVertexData vertexDatatop = vertex_data_comm_right_edge_stack->getTopElementRef();
	TVertexData vertexDataleft = vertex_data_comm_left_edge_stack->pop_returnRef();
	cKernelClass.op_cell(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, &vertexDataleft, &vertexDataright, &vertexDatatop);
}

inline void K_o_bnb_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_e_nnb_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		V_e_bbo_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	TVertexData vertexDataleft = vertex_data_comm_left_edge_stack->pop_returnRef();
	// isMiddleTouchVertex
	TVertexData vertexDatatop = vertex_data_comm_left_edge_stack->getTopElementRef();
	// isMiddleTouchVertex
	TVertexData vertexDataright = vertex_data_comm_right_edge_stack->getTopElementRef();
	cKernelClass.op_cell(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, &vertexDataleft, &vertexDataright, &vertexDatatop);
}

inline void K_e_bob_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int depth)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		depth++;
		H_o_bbn_forward(vx2, vy2, vx0, vy0, mx, my, depth);
		V_o_oob_forward(vx1, vy1, vx2, vy2, mx, my, depth);
		return;
	}
	CCellData *element_data = element_data_fifo.getNextDataPtr();
	TVertexData vertexDataright = vertex_data_comm_right_edge_stack->pop_returnRef();
	TVertexData vertexDatatop = vertex_data_comm_right_edge_stack->pop_returnRef();
	TVertexData vertexDataleft = vertex_data_comm_left_edge_stack->pop_returnRef();
	cKernelClass.op_cell(vx0, vy0, vx1, vy1, vx2, vy2, depth, element_data, &vertexDataleft, &vertexDataright, &vertexDatatop);
}

static const int number_of_recursion_functions = 160;
typedef void (TThisClass::*TRecursiveMethod)(TVertexScalar, TVertexScalar, TVertexScalar, TVertexScalar, TVertexScalar, TVertexScalar, int);
enum ESFCMethod{
	SFC_METHOD_DEFAULT = 0,
	SFC_METHOD_FORCE_FORWARD = (1 << 0),
	SFC_METHOD_FORCE_BACKWARD = (1 << 1),
	SFC_METHOD_NEW_TO_OLD_EDGE_TYPES = (1 << 2),
	SFC_METHOD_OLD_TO_NEW_EDGE_TYPES = (1 << 3),
	SFC_METHOD_LIMITER___ = (1 << 4)
};

template <int specialMode = 0>
TRecursiveMethod getSFCMethod(CTriangle_Factory &i_cTriangleFactory)
{
	static TRecursiveMethod methodArray [3] [2] [27] [2] =
	{
	{
	{
	{
		&TThisClass::K_e_nnn_forward ,
		&TThisClass::K_e_nnn_backward 
	} ,
	{
		&TThisClass::K_e_nno_forward ,
		nullptr 
	} ,
	{
		&TThisClass::K_e_nnb_forward ,
		&TThisClass::K_e_nnb_backward 
	} ,
	{
		nullptr ,
		nullptr 
	} ,
	{
		&TThisClass::K_e_noo_forward ,
		nullptr 
	} ,
	{
		nullptr ,
		nullptr 
	} ,
	{
		&TThisClass::K_e_nbn_forward ,
		&TThisClass::K_e_nbn_backward 
	} ,
	{
		&TThisClass::K_e_nbo_forward ,
		nullptr 
	} ,
	{
		&TThisClass::K_e_nbb_forward ,
		&TThisClass::K_e_nbb_backward 
	} ,
	{
		nullptr ,
		&TThisClass::K_e_onn_backward 
	} ,
	{
		nullptr ,
		nullptr 
	} ,
	{
		nullptr ,
		nullptr 
	} ,
	{
		nullptr ,
		&TThisClass::K_e_oon_backward 
	} ,
	{
		&TThisClass::K_e_ooo_forward ,
		&TThisClass::K_e_ooo_backward 
	} ,
	{
		&TThisClass::K_e_oob_forward ,
		&TThisClass::K_e_oob_backward 
	} ,
	{
		nullptr ,
		&TThisClass::K_e_obn_backward 
	} ,
	{
		&TThisClass::K_e_obo_forward ,
		&TThisClass::K_e_obo_backward 
	} ,
	{
		&TThisClass::K_e_obb_forward ,
		&TThisClass::K_e_obb_backward 
	} ,
	{
		&TThisClass::K_e_bnn_forward ,
		&TThisClass::K_e_bnn_backward 
	} ,
	{
		&TThisClass::K_e_bno_forward ,
		nullptr 
	} ,
	{
		&TThisClass::K_e_bnb_forward ,
		&TThisClass::K_e_bnb_backward 
	} ,
	{
		nullptr ,
		&TThisClass::K_e_bon_backward 
	} ,
	{
		&TThisClass::K_e_boo_forward ,
		&TThisClass::K_e_boo_backward 
	} ,
	{
		&TThisClass::K_e_bob_forward ,
		&TThisClass::K_e_bob_backward 
	} ,
	{
		&TThisClass::K_e_bbn_forward ,
		&TThisClass::K_e_bbn_backward 
	} ,
	{
		&TThisClass::K_e_bbo_forward ,
		&TThisClass::K_e_bbo_backward 
	} ,
	{
		&TThisClass::K_e_bbb_forward ,
		&TThisClass::K_e_bbb_backward 
	} 
	} ,
	{
	{
		&TThisClass::K_o_nnn_forward ,
		&TThisClass::K_o_nnn_backward 
	} ,
	{
		nullptr ,
		nullptr 
	} ,
	{
		&TThisClass::K_o_nnb_forward ,
		&TThisClass::K_o_nnb_backward 
	} ,
	{
		&TThisClass::K_o_non_forward ,
		nullptr 
	} ,
	{
		&TThisClass::K_o_noo_forward ,
		nullptr 
	} ,
	{
		&TThisClass::K_o_nob_forward ,
		nullptr 
	} ,
	{
		&TThisClass::K_o_nbn_forward ,
		&TThisClass::K_o_nbn_backward 
	} ,
	{
		nullptr ,
		nullptr 
	} ,
	{
		&TThisClass::K_o_nbb_forward ,
		&TThisClass::K_o_nbb_backward 
	} ,
	{
		nullptr ,
		&TThisClass::K_o_onn_backward 
	} ,
	{
		nullptr ,
		&TThisClass::K_o_ono_backward 
	} ,
	{
		nullptr ,
		&TThisClass::K_o_onb_backward 
	} ,
	{
		nullptr ,
		nullptr 
	} ,
	{
		&TThisClass::K_o_ooo_forward ,
		&TThisClass::K_o_ooo_backward 
	} ,
	{
		&TThisClass::K_o_oob_forward ,
		&TThisClass::K_o_oob_backward 
	} ,
	{
		nullptr ,
		nullptr 
	} ,
	{
		&TThisClass::K_o_obo_forward ,
		&TThisClass::K_o_obo_backward 
	} ,
	{
		&TThisClass::K_o_obb_forward ,
		&TThisClass::K_o_obb_backward 
	} ,
	{
		&TThisClass::K_o_bnn_forward ,
		&TThisClass::K_o_bnn_backward 
	} ,
	{
		nullptr ,
		&TThisClass::K_o_bno_backward 
	} ,
	{
		&TThisClass::K_o_bnb_forward ,
		&TThisClass::K_o_bnb_backward 
	} ,
	{
		&TThisClass::K_o_bon_forward ,
		nullptr 
	} ,
	{
		&TThisClass::K_o_boo_forward ,
		&TThisClass::K_o_boo_backward 
	} ,
	{
		&TThisClass::K_o_bob_forward ,
		&TThisClass::K_o_bob_backward 
	} ,
	{
		&TThisClass::K_o_bbn_forward ,
		&TThisClass::K_o_bbn_backward 
	} ,
	{
		&TThisClass::K_o_bbo_forward ,
		&TThisClass::K_o_bbo_backward 
	} ,
	{
		&TThisClass::K_o_bbb_forward ,
		&TThisClass::K_o_bbb_backward 
	} 
	} 
	} ,
	{
	{
	{
		&TThisClass::H_e_nnn_forward ,
		nullptr 
	} ,
	{
		nullptr ,
		nullptr 
	} ,
	{
		&TThisClass::H_e_nnb_forward ,
		nullptr 
	} ,
	{
		nullptr ,
		&TThisClass::H_e_non_backward 
	} ,
	{
		nullptr ,
		&TThisClass::H_e_noo_backward 
	} ,
	{
		nullptr ,
		&TThisClass::H_e_nob_backward 
	} ,
	{
		nullptr ,
		nullptr 
	} ,
	{
		nullptr ,
		nullptr 
	} ,
	{
		nullptr ,
		nullptr 
	} ,
	{
		&TThisClass::H_e_onn_forward ,
		nullptr 
	} ,
	{
		&TThisClass::H_e_ono_forward ,
		nullptr 
	} ,
	{
		&TThisClass::H_e_onb_forward ,
		nullptr 
	} ,
	{
		nullptr ,
		nullptr 
	} ,
	{
		nullptr ,
		&TThisClass::H_e_ooo_backward 
	} ,
	{
		nullptr ,
		&TThisClass::H_e_oob_backward 
	} ,
	{
		nullptr ,
		nullptr 
	} ,
	{
		nullptr ,
		nullptr 
	} ,
	{
		nullptr ,
		nullptr 
	} ,
	{
		&TThisClass::H_e_bnn_forward ,
		nullptr 
	} ,
	{
		&TThisClass::H_e_bno_forward ,
		nullptr 
	} ,
	{
		&TThisClass::H_e_bnb_forward ,
		nullptr 
	} ,
	{
		nullptr ,
		&TThisClass::H_e_bon_backward 
	} ,
	{
		nullptr ,
		&TThisClass::H_e_boo_backward 
	} ,
	{
		nullptr ,
		&TThisClass::H_e_bob_backward 
	} ,
	{
		nullptr ,
		nullptr 
	} ,
	{
		nullptr ,
		nullptr 
	} ,
	{
		nullptr ,
		nullptr 
	} 
	} ,
	{
	{
		&TThisClass::H_o_nnn_forward ,
		nullptr 
	} ,
	{
		nullptr ,
		&TThisClass::H_o_nno_backward 
	} ,
	{
		nullptr ,
		nullptr 
	} ,
	{
		nullptr ,
		nullptr 
	} ,
	{
		nullptr ,
		&TThisClass::H_o_noo_backward 
	} ,
	{
		nullptr ,
		nullptr 
	} ,
	{
		&TThisClass::H_o_nbn_forward ,
		nullptr 
	} ,
	{
		nullptr ,
		&TThisClass::H_o_nbo_backward 
	} ,
	{
		nullptr ,
		nullptr 
	} ,
	{
		&TThisClass::H_o_onn_forward ,
		nullptr 
	} ,
	{
		nullptr ,
		nullptr 
	} ,
	{
		nullptr ,
		nullptr 
	} ,
	{
		&TThisClass::H_o_oon_forward ,
		nullptr 
	} ,
	{
		nullptr ,
		&TThisClass::H_o_ooo_backward 
	} ,
	{
		nullptr ,
		nullptr 
	} ,
	{
		&TThisClass::H_o_obn_forward ,
		nullptr 
	} ,
	{
		nullptr ,
		&TThisClass::H_o_obo_backward 
	} ,
	{
		nullptr ,
		nullptr 
	} ,
	{
		&TThisClass::H_o_bnn_forward ,
		nullptr 
	} ,
	{
		nullptr ,
		&TThisClass::H_o_bno_backward 
	} ,
	{
		nullptr ,
		nullptr 
	} ,
	{
		&TThisClass::H_o_bon_forward ,
		nullptr 
	} ,
	{
		nullptr ,
		&TThisClass::H_o_boo_backward 
	} ,
	{
		nullptr ,
		nullptr 
	} ,
	{
		&TThisClass::H_o_bbn_forward ,
		nullptr 
	} ,
	{
		nullptr ,
		&TThisClass::H_o_bbo_backward 
	} ,
	{
		nullptr ,
		nullptr 
	} 
	} 
	} ,
	{
	{
	{
		&TThisClass::V_e_nnn_forward ,
		&TThisClass::V_e_nnn_backward 
	} ,
	{
		&TThisClass::V_e_nno_forward ,
		nullptr 
	} ,
	{
		&TThisClass::V_e_nnb_forward ,
		nullptr 
	} ,
	{
		nullptr ,
		&TThisClass::V_e_non_backward 
	} ,
	{
		nullptr ,
		nullptr 
	} ,
	{
		nullptr ,
		&TThisClass::V_e_nob_backward 
	} ,
	{
		nullptr ,
		&TThisClass::V_e_nbn_backward 
	} ,
	{
		&TThisClass::V_e_nbo_forward ,
		nullptr 
	} ,
	{
		nullptr ,
		nullptr 
	} ,
	{
		nullptr ,
		nullptr 
	} ,
	{
		&TThisClass::V_e_ono_forward ,
		nullptr 
	} ,
	{
		&TThisClass::V_e_onb_forward ,
		nullptr 
	} ,
	{
		nullptr ,
		&TThisClass::V_e_oon_backward 
	} ,
	{
		&TThisClass::V_e_ooo_forward ,
		&TThisClass::V_e_ooo_backward 
	} ,
	{
		nullptr ,
		&TThisClass::V_e_oob_backward 
	} ,
	{
		nullptr ,
		&TThisClass::V_e_obn_backward 
	} ,
	{
		&TThisClass::V_e_obo_forward ,
		nullptr 
	} ,
	{
		nullptr ,
		nullptr 
	} ,
	{
		&TThisClass::V_e_bnn_forward ,
		&TThisClass::V_e_bnn_backward 
	} ,
	{
		&TThisClass::V_e_bno_forward ,
		nullptr 
	} ,
	{
		&TThisClass::V_e_bnb_forward ,
		nullptr 
	} ,
	{
		nullptr ,
		&TThisClass::V_e_bon_backward 
	} ,
	{
		&TThisClass::V_e_boo_forward ,
		&TThisClass::V_e_boo_backward 
	} ,
	{
		nullptr ,
		&TThisClass::V_e_bob_backward 
	} ,
	{
		nullptr ,
		&TThisClass::V_e_bbn_backward 
	} ,
	{
		&TThisClass::V_e_bbo_forward ,
		nullptr 
	} ,
	{
		nullptr ,
		nullptr 
	} 
	} ,
	{
	{
		&TThisClass::V_o_nnn_forward ,
		&TThisClass::V_o_nnn_backward 
	} ,
	{
		nullptr ,
		&TThisClass::V_o_nno_backward 
	} ,
	{
		nullptr ,
		&TThisClass::V_o_nnb_backward 
	} ,
	{
		&TThisClass::V_o_non_forward ,
		nullptr 
	} ,
	{
		nullptr ,
		nullptr 
	} ,
	{
		&TThisClass::V_o_nob_forward ,
		nullptr 
	} ,
	{
		&TThisClass::V_o_nbn_forward ,
		nullptr 
	} ,
	{
		nullptr ,
		&TThisClass::V_o_nbo_backward 
	} ,
	{
		nullptr ,
		nullptr 
	} ,
	{
		nullptr ,
		nullptr 
	} ,
	{
		nullptr ,
		&TThisClass::V_o_ono_backward 
	} ,
	{
		nullptr ,
		&TThisClass::V_o_onb_backward 
	} ,
	{
		&TThisClass::V_o_oon_forward ,
		nullptr 
	} ,
	{
		&TThisClass::V_o_ooo_forward ,
		&TThisClass::V_o_ooo_backward 
	} ,
	{
		&TThisClass::V_o_oob_forward ,
		nullptr 
	} ,
	{
		&TThisClass::V_o_obn_forward ,
		nullptr 
	} ,
	{
		nullptr ,
		&TThisClass::V_o_obo_backward 
	} ,
	{
		nullptr ,
		nullptr 
	} ,
	{
		&TThisClass::V_o_bnn_forward ,
		&TThisClass::V_o_bnn_backward 
	} ,
	{
		nullptr ,
		&TThisClass::V_o_bno_backward 
	} ,
	{
		nullptr ,
		&TThisClass::V_o_bnb_backward 
	} ,
	{
		&TThisClass::V_o_bon_forward ,
		nullptr 
	} ,
	{
		&TThisClass::V_o_boo_forward ,
		&TThisClass::V_o_boo_backward 
	} ,
	{
		&TThisClass::V_o_bob_forward ,
		nullptr 
	} ,
	{
		&TThisClass::V_o_bbn_forward ,
		nullptr 
	} ,
	{
		nullptr ,
		&TThisClass::V_o_bbo_backward 
	} ,
	{
		nullptr ,
		nullptr 
	} 
	} 
	} 
	} 	;

	assert(i_cTriangleFactory.triangleType != CTriangle_Enums::TRIANGLE_TYPE_INVALID);
	assert(i_cTriangleFactory.evenOdd != CTriangle_Enums::EVEN_ODD_INVALID);

		assert(i_cTriangleFactory.edgeTypes.hyp != CTriangle_Enums::EDGE_TYPE_INVALID);
		assert(i_cTriangleFactory.edgeTypes.left != CTriangle_Enums::EDGE_TYPE_INVALID);
		assert(i_cTriangleFactory.edgeTypes.right != CTriangle_Enums::EDGE_TYPE_INVALID);
		CTriangle_Enums::EEdgeType hyp, left, right;
		if (specialMode == 0)
		{
			hyp = i_cTriangleFactory.edgeTypes.hyp;
			right = i_cTriangleFactory.edgeTypes.right;
			left = i_cTriangleFactory.edgeTypes.left;
		}
		else if (specialMode & SFC_METHOD_NEW_TO_OLD_EDGE_TYPES)
		{
			hyp = (i_cTriangleFactory.edgeTypes.hyp == CTriangle_Enums::EDGE_TYPE_NEW ? CTriangle_Enums::EDGE_TYPE_OLD : i_cTriangleFactory.edgeTypes.hyp);
			right = (i_cTriangleFactory.edgeTypes.right == CTriangle_Enums::EDGE_TYPE_NEW ? CTriangle_Enums::EDGE_TYPE_OLD : i_cTriangleFactory.edgeTypes.right);
			left = (i_cTriangleFactory.edgeTypes.left == CTriangle_Enums::EDGE_TYPE_NEW ? CTriangle_Enums::EDGE_TYPE_OLD : i_cTriangleFactory.edgeTypes.left);
		}
		else if (specialMode & SFC_METHOD_OLD_TO_NEW_EDGE_TYPES)
		{
			hyp = (i_cTriangleFactory.edgeTypes.hyp == CTriangle_Enums::EDGE_TYPE_OLD ? CTriangle_Enums::EDGE_TYPE_NEW : i_cTriangleFactory.edgeTypes.hyp);
			right = (i_cTriangleFactory.edgeTypes.right == CTriangle_Enums::EDGE_TYPE_OLD ? CTriangle_Enums::EDGE_TYPE_NEW : i_cTriangleFactory.edgeTypes.right);
			left = (i_cTriangleFactory.edgeTypes.left == CTriangle_Enums::EDGE_TYPE_OLD ? CTriangle_Enums::EDGE_TYPE_NEW : i_cTriangleFactory.edgeTypes.left);
		}
	#if DEBUG
		else
		{
			assert(false);
		}
	#endif
	CTriangle_Enums::EDirection direction;
	if (specialMode & SFC_METHOD_FORCE_FORWARD)
	{
		direction = CTriangle_Enums::DIRECTION_FORWARD;
	}
	else if (specialMode & SFC_METHOD_FORCE_BACKWARD)
	{
		direction = CTriangle_Enums::DIRECTION_BACKWARD;
	}
	else
	{
		direction = i_cTriangleFactory.traversalDirection;
	}

		assert(i_cTriangleFactory.traversalDirection != CTriangle_Enums::DIRECTION_INVALID);
	assert(i_cTriangleFactory.hypNormal != CTriangle_Enums::NORMAL_INVALID);
#if DEBUG
	assert(methodArray[i_cTriangleFactory.triangleType][i_cTriangleFactory.evenOdd][hyp*9+right*3+left][direction] != nullptr);
#endif
	return methodArray[i_cTriangleFactory.triangleType][i_cTriangleFactory.evenOdd][hyp*9+right*3+left][direction];
}
